/*****************************************************************************
*	NVR Estimator Class Define JavaScript
*
*
*
*****************************************************************************/

var kilo = 1024;

function addNumCommas(nStr) {
    nStr += '';
    var x = nStr.split('.');
    var x1 = x[0];
    var x2 = x.length > 1 ? '.' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2');
    }
    return x1 + x2;
}

function Units()
{
	this.capacity_unit = ["KB", "MB", "GB", "TB", "PB", "EB"]; // explr

    this.name_list = new Array("bps", "Kbps", "Mbps", "Bps", "KBps", "MBps");
    this.name_list_unit_only = new Array("Bits", "Kilo bits", "Mega bits", "Bytes", "Kilo bytes", "Mega bytes");
    this.scale_list = new Array(1.0 / kilo, 1, 1 * kilo, 8.0 / kilo, 8, 8 * kilo);

	this.changeOtherUnit = function(value, unitIndex)
	{
		var result = value;
		var selectedUnit = document.getElementById("select_display_unit").selectedIndex;

		result = value * (this.scale_list[selectedUnit] / this.scale_list[unitIndex]);

		return Math.round(result *100) / 100;
	}

	this.withUnit = function(Kbps)
	{
		var selectedUnit = document.getElementById("select_display_unit").selectedIndex;
		var value = (Math.round((Kbps / this.scale_list[selectedUnit]) * 100) / 100);

		return  addNumCommas(value) + " " + this.name_list[selectedUnit];
	}
	this.getOnlyUnit = function()
	{
		var selectedUnit = document.getElementById("select_display_unit").selectedIndex;

		return " " + this.name_list[selectedUnit];
	}
	this.withFitUnit = function(kbps)
	{
		var num = kbps  / 8;
		var index = 0;
		for (x in this.capacity_unit) {
			if (1 < (num / 1024)) {
				num /= 1024;
				++index;
			}
			else {
				break;
			}
		}

		if (this.capacity_unit.length == index)
		{
			--index;
			num *= 1024;
		}

		var value = (Math.round(num*100) / 100);
		if ((value % 1024) == 0 && value != 0) { value = value / 1024;  index++;}
		return  addNumCommas(value) + " " + this.capacity_unit[index];
	}
}

// function NVRDevice(name, max_hdd_count, max_bitrate, max_ips, max_channel, ableLiveControl)
// {
	// this.nvr_name 		= name;				//String
	// this.max_hdd_count	= max_hdd_count;	//int
	// this.max_bitrate	= max_bitrate;		//int
	// this.max_ips		= max_ips;
	// this.max_channel	= max_channel;		//int
	// this.ableLiveControl= ableLiveControl;	//boolean
// }

function NVRDevice (model,
								name,
								supportedCodec,
								supportHDD,
								supportMaxResolution,
								maxSingleIPS,
								maxTotalIPS,
								maxSingleBitrate,
								maxTotalLiveStreamBitrate,
								maxTotalRemoteStreamBitrate,
								maxTotalBitrate,
								supportLive,
								maxStreamCount,
								maxChannelCount,
								defaultCodec,
								defaultResolution,
								defaultFramelate,
								defaultQuality,
								model_group,
								real_bitrate_arr)
{
	this.model_group			= model_group; // int
	this.model							= model;
	this.nvr_name 						= name;						// String
	this.directCameraCount 		= maxChannelCount;
	this.max_record_bitrate 		= maxSingleBitrate; 	// int
	this.max_record_ips 			= maxSingleIPS; 		// int
	this.support_compression 	= supportedCodec; //Array
	this.base_hdd_count 			= 3;		// int
	this.max_remote_bitrate 		= maxSingleBitrate; 	// Array
	this.max_remote_ips 			= maxSingleIPS; 		// Array
	this.max_live_bitrate 			= maxSingleBitrate;		// int
	this.max_live_ips 					= maxSingleIPS;			// int
	this.supported_hdd_list		= supportHDD	//array
	this.live_control_able 			= (0 < supportLive);		// boolean
	this.max_total_live_bitrate     = maxTotalLiveStreamBitrate;
	this.max_total_remote_bitrate = maxTotalRemoteStreamBitrate;

	if (real_bitrate_arr != null) 
		this.real_bitrate_arr = real_bitrate_arr;
	else 
		this.real_bitrate_arr = [];
}

//camera device list gloval var is [g_caemra_device_list]
function CameraDevice(model,
							 		 name,
						 		 	 maxSingleBitrate,
					 				 maxTotalBitrate,
									 maxStreamCount,
									 audioSupport,
									 codecs,
									 model_group,
                                     calc_func)
{
	this.model_group = model_group;		//int
	this.model_name	= name;		//String
	this.audio_count = audioSupport;		//int
	this.codec_list	= codecs;		//ArrayList
    this.calc_func = calc_func; //function
}

function Codec (name,
						 codecFactor,
						 resolution,
						 framelate,
						 quality,
						 resolutionFactor,
						 resolutionBasi,
						 qualityIncreseRate)
{
	this.codec_name					= name;						//String
	this.constant_bitrate_base	= codecFactor;	//float
	this.supprot_resolution_list	= resolution;	//ArrayList
	this.support_framerate_list 	= framelate;	//ArrayList
	this.support_quality_list		= quality;		//ArrayList
	
	this.resolution_factor_list		= resolutionFactor;	//ArrayList
	this.resolution_bias_list		= resolutionBasi;		//ArrayList
	this.quality_factor_list			= qualityIncreseRate;		//ArrayList
}

function VideoProfile(codec_index, resolution_index, quality_index, framerate_index)
{
	this.selected_codec_index		= codec_index;		//int
	this.selected_resolution_index	= resolution_index;	//int
	this.selected_quality_index		= quality_index;	//int
	this.selected_framerate_index	= framerate_index;	//int
}

function CameraProfile(camera_index, live1_profile, live2_profile, remote_profile, timelaps_profile, event_profile, event_ratio,
						camera_count, audio_count)
{

	this.camera_index 				= camera_index;			//int
	this.live1_profile 				= live1_profile;		//VideoProfile
	this.live2_profile				= live2_profile;		//VideoProfile
	this.remote_profile 			= remote_profile;		//VideoProfile
	this.timelaps_video_profile		= timelaps_profile; 	//VideoProfile
	this.event_video_profile		= event_profile; 		//VideoProfile
	this.event_ratio				= event_ratio;			//int
	this.camera_count				= camera_count;			//int
	this.audio_count				= audio_count;			//int

	this.live1_bitrate	= 0;			//float
	this.live2_bitrate	= 0;			//float
	this.remote_bitrate = 0;			//float
	this.timelaps_bitrate = 0;			//float
	this.event_bitrate = 0;				//float

	this.isCustomCamera = false;	//boolean

	this.calculatethis = function () {
		//camear_index가 현제 카메라의 카운터와 같을경우 coustom으로 판단하고 계산을 진행하지 않는다.
		this.live1_bitrate 	= calculateStreamBitrate(this.camera_index, this.live1_profile, 1, 0) * this.camera_count;
		this.live2_bitrate 	= calculateStreamBitrate(this.camera_index, this.live2_profile, 1, 1) * this.camera_count;
		this.remote_bitrate = calculateStreamBitrate(this.camera_index, this.remote_profile, 1, 2) * this.camera_count;
		this.timelaps_bitrate = calculateStreamBitrate(this.camera_index, this.timelaps_video_profile, 1 - this.event_ratio, 3) * this.camera_count;
		this.event_bitrate 	= calculateStreamBitrate(this.camera_index, this.event_video_profile, this.event_ratio, 4) * this.camera_count;
	}

	this.getBitrateForSingeCamera = function() {
		return this.remote_bitrate +
				this.live1_bitrate +
				this.live2_bitrate +
				this.timelaps_bitrate +
				this.event_bitrate;
	}

	this.getTotalBitrate = function() {
		var totalBitrate =  this.getBitrateForSingeCamera() * this.camera_count;

		return totalBitrate;
	}
	
	this.calculateAnalog = function() {
		this.live1_bitrate 	= 0;
		this.live2_bitrate 	= 0;
		this.remote_bitrate = 0;
		this.timelaps_bitrate = calculateAnalogBitrate(this.camera_index, this.timelaps_video_profile, 1 - this.event_ratio, 3) * this.camera_count;
		this.event_bitrate 	= calculateAnalogBitrate(this.camera_index, this.event_video_profile, this.event_ratio, 4) * this.camera_count;
	}
}

/**********************************************************************************************
*
*
**********************************************************************************************/
