﻿//--------------------------------------------------
//	Define const values
//--------------------------------------------------
	var BUILD_TYPE = "" // BRAND_ONLINE

	var HIDE_DETAIL_LAYOUT = 0;
	var SHOW_DETAIL_LAYOUT = 1;

	var STREAM_LIVE1 = 0;
	var STREAM_LIVE2 = 1;
	var STREAM_REMOTE = 2;
	var STREAM_RECORD_TIMELAPS = 3;
	var STREAM_RECORD_EVENT = 4;

	var FIXED = 1;

	var CAMERA_SETTTING_MODE_INSERT = 0;
	var CAMERA_SETTTING_MODE_MODIFY = 1;

	var DEFAULT_UNIT_INDEX = 2;

    var MODEL_GROUP_EXXO = 16;
    var MODEL_GROUP_SPRATA = 11;
    
	var MODEL_GROUP_VMS = 98;
	var MODEL_GROUP_DVR = 99;
	
    var HDD_RAID_NONE = 0;
    var HDD_RAID5 = 1;
    
    var HDD_RAID_INCREASE_RATE = [1, 1.5];
//--------------------------------------------------
//	Global values
//--------------------------------------------------

var g_nvr_list = new Array();
var g_camera_group_list = new Array();
var g_detail_layout_status = HIDE_DETAIL_LAYOUT;
var g_unit_selected = 0;
var g_selected_camera_list = new Array();

var g_camera_device_list 	= new Array();
var g_nvr_device_list 		= new Array();
var g_camera_profile_list 	= new Array();

var g_current_nvr_model		= new NVRDevice();
var g_current_camera_model;
var g_current_camera_profile;
var g_modify_camera_profile	= new CameraProfile();
var g_modify_index;
var g_before_modify_camera_profile= new CameraProfile();
var g_unit = new Units();
var g_hdd_list = [1024, 2048, 3072, 10240, 1024 * 12, 1024 * 18, 1024 * 20]; //GB
var g_current_hdd_size = 1024;
var g_isCustomCamera = false;
var g_hdd_raid_mode = 0;

var g_setting_mode = CAMERA_SETTTING_MODE_INSERT;
//--------------------------------------------------
//	initialize
//--------------------------------------------------

function initialize()
{
	//init version
	document.getElementById("label_version").textContent = "v " + VERSION;
	//init control valuesselect_timelaps_framerate
	init_nvr_models();
	init_hdd_capacity();
	init_bandwidth_unit();
	init_camera_models();
	init_codecs();
	init_camera_profile("live1");
	init_camera_profile("live2");
	init_camera_profile("remote");
	init_camera_profile("timelaps");
	init_camera_profile("event");
	//init_selectedIndex();

	onChangeCameraModel(document.getElementById("select_camera_model"));
	clearSelectedCameraList();
}

function init_nvr_models()
{

	var list = new Array();

	for (x in g_nvr_device_list) {
		list.push(g_nvr_device_list[x].nvr_name);
	}
	replaceList("select_nvr_model", list);
	var index = document.getElementById("select_nvr_model").selectedIndex;
	if (index != null)
		g_current_nvr_model = g_nvr_device_list[index];
	
	if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
		hideNonAnalogStreams(true);
	}
	else {
		hideNonAnalogStreams(false);
	}
}

function init_hdd_capacity()
{
	var list = new Array();
	g_hdd_list = g_current_nvr_model.supported_hdd_list;
	for ( x in g_hdd_list) {
		var capacity;
		if (g_hdd_list[x] < 1024) {
			capacity = g_hdd_list[x] + " GB";
		}
		else {
			capacity = (g_hdd_list[x] / 1024) + " TB";
		}
		list.push(capacity);
	}

	replaceList("select_hdd_capacity", list);
}

function init_bandwidth_unit()
{
	var list = new Units();
	replaceList("select_display_unit", list.name_list);
	document.getElementById("select_display_unit").selectedIndex = DEFAULT_UNIT_INDEX;
	g_unit_selected = DEFAULT_UNIT_INDEX;
}

function init_camera_models()
{
	var list = new Array();

	for (x in g_camera_device_list) {
		if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
			if (g_camera_device_list[x].model_group == MODEL_GROUP_DVR) {
				list.push(g_camera_device_list[x].model_name);
			}
		}
		else {
			if (g_camera_device_list[x].model_group != MODEL_GROUP_DVR) {
				list.push(g_camera_device_list[x].model_name);
			}
		}
	}	
	//	list.push("Custom Camera");

	replaceList("select_camera_model", list);
	
	var index = document.getElementById("select_camera_model").selectedIndex;
	g_current_camera_model = getCameraModel(index);
}

function init_codecs()
{
	if (g_isCustomCamera) {
		return;
	}

	var selectedCamera = document.getElementById("select_camera_model").selectedIndex;
	var codecNameList = new Array();
	
	var current_camera = g_current_camera_model;

	for (i in current_camera.codec_list) {
		codecNameList.push(current_camera.codec_list[i].codec_name);
	}

	replaceList("select_live1_codec",  codecNameList);
	replaceList("select_live2_codec",  codecNameList);
	replaceList("select_remote_codec",  codecNameList);
	replaceList("select_timelaps_codec",  codecNameList);
	replaceList("select_event_codec",  codecNameList);
}

function init_controls_enable()
{
	var controls = ["codec", "resolution", "framerate", "quality"];
	var profiles = ["live1", "live2", "remote"];
	var recordProfiles = ["timelaps", "event"];

	g_current_camera_profile = new CameraProfile();

	for (i in profiles) {
		for (j in controls) {
			document.getElementById("select_"+profiles[i]+"_"+controls[j]).disabled = g_isCustomCamera;
		}
		document.getElementById("input_"+profiles[i]+"_bandwidth").disabled = !g_isCustomCamera;
	}

	for (i in recordProfiles) {
		for (j in controls) {
			document.getElementById("select_"+recordProfiles[i]+"_"+controls[j]).disabled = g_isCustomCamera ||
			!document.getElementById("check_use_"+recordProfiles[i]).checked;
		}
		document.getElementById("input_"+recordProfiles[i]+"_bandwidth").disabled = !g_isCustomCamera ||
		!document.getElementById("check_use_"+recordProfiles[i]).checked;
	}
	document.getElementById("input_event_ratio").disabled = g_isCustomCamera;

	onClickRecordProfileCheck(document.getElementById("check_use_timelaps"));
	onClickRecordProfileCheck(document.getElementById("check_use_event"));

	disable_controls_list();
}

function disable_controls_list()
{
	var controls = ["codec", "resolution", "framerate", "quality"];
	var profiles = ["live1", "live2", "remote", "timelaps", "event"];

	for (i in 1) {
		for (j in controls) {
			document.getElementById("select_"+profiles[i]+"_"+controls[j]).disabled = !g_current_nvr_model.live_control_able;
		}
	}

	// for (i in profiles) {
		// document.getElementById("select_"+profiles[i]+"_codec").disabled = 1; // disable codec list
	// }
}

function init_camera_profile(name)
{
	var selectedCamera = document.getElementById("select_camera_model").selectedIndex;
	var index = document.getElementById("select_"+name+"_codec").selectedIndex;
	
	var current_camera = g_current_camera_model;
	var codec = current_camera.codec_list[index];
	var resolution_list = codec.supprot_resolution_list;
	var framerate_list = codec.support_framerate_list;
	if (g_current_nvr_model.model_group == MODEL_GROUP_DVR &&
		 codec.resolution_factor_list[0] == 3) { 
			if (g_current_nvr_model.max_record_ips[3] == 10) {
				framerate_list = [1, 2, 3, 4, 5, 10];
			}
			else if (g_current_nvr_model.max_record_ips[3] == 15) {
				framerate_list = [1, 2, 3, 4, 5, 10, 15];
			}
	}
    
    // VMS를 제외한 현재 NVR에서는 60ips를 지원하지 않는다.
    if (g_current_nvr_model.model_group !=  MODEL_GROUP_VMS) {
        var index = framerate_list.indexOf(60);
        if (0 < index) {
            framerate_list = framerate_list.slice(0, index);
        }
    }
    if (g_current_nvr_model.model_group == 0 ||
		g_current_nvr_model.model_group == 1 ||
		g_current_nvr_model.model_group == 4 ||
		g_current_nvr_model.model_group == 5 ||
		g_current_nvr_model.model_group == 8)	{
			var res_index = resolution_list.indexOf("3840x2160");
			if(res_index > 0)	{
				resolution_list = resolution_list.slice(0, res_index);
			}
	}
	replaceList("select_" + name + "_resolution", resolution_list);
	replaceList("select_" + name + "_framerate",  framerate_list);
	replaceList("select_" + name + "_quality",  codec.support_quality_list);
}

function init_selectedIndex()
{
	var live1Res  	= document.getElementById("select_live1_resolution");
	var live2Res  	= document.getElementById("select_live2_resolution");
	var remoteRes 	= document.getElementById("select_remote_resolution");
	var timelapsRes	= document.getElementById("select_timelaps_resolution");
	var eventRes	= document.getElementById("select_event_resolution");

	var live1frame 		= document.getElementById("select_live1_framerate");
	var live2frame 		= document.getElementById("select_live2_framerate");
	var remoteframe 	= document.getElementById("select_remote_framerate");
	var timelapsframe	= document.getElementById("select_timelaps_framerate");
	var eventframe		= document.getElementById("select_event_framerate");

	var live1quality 	= document.getElementById("select_live1_quality");
	var live2quality 	= document.getElementById("select_live2_quality");
	var remotequality 	= document.getElementById("select_remote_quality");
	var timelapsquality	= document.getElementById("select_timelaps_quality");
	var eventquality	= document.getElementById("select_event_quality");

	live1Res.selectedIndex = live1Res.length - 3;
	remoteRes.selectedIndex = 1; // 640 x 360
	if (live2Res.length > 1) {
		live2Res.selectedIndex = 1;
	}

	timelapsRes.selectedIndex = live1Res.selectedIndex;
	eventRes.selectedIndex = live1Res.selectedIndex;

	//--------------------------------------------------------------
	var live1frame_index = 0;
	var live2frame_index = 0;
	var currentCameraIndex = document.getElementById("select_camera_model").selectedIndex;
	var current_camera = g_current_camera_model;
	live1frame_index = live1frame.length - 1; // 30 ips
	live2frame_index = live2frame.length - 1; // 30 ips
/* 	switch (g_current_nvr_model.model_group) {
		case 5: // DR-4132(P)
			switch (current_camera.model_group) {
				case 12: // 2MP camera
					live1frame_index = live1frame.length - 2; // 15 ips
					live2frame_index = live2frame.length - 2; // 15 ips
					break;
				default:
					live1frame_index = live1frame.length - 2; // 30 ips
					live2frame_index = live2frame.length - 2; // 30 ips
					break;
			}
			break;
		case 10: // DR-6232P
			live2frame_index = live2frame.length - 2; // 15 ips

			switch (current_camera.model_group) {
				case 12: // 2MP camera
					live1frame_index = live1frame.length - 2; // 15 ips
					break;
				default:
					live1frame_index = live1frame.length - 1; // 30 ips
					break;
			}
			break;
		case 1: // DR-2116P
			live2frame_index = live2frame.length - 2; // 15 ips

			switch (current_camera.model_group) {
				case 12: // 2MP camera
					live1frame_index = live1frame.length - 2; // 15 ips
					break;
				case 11: // 1MP camera
					live1frame_index = live1frame.length - 1; // 30 ips
					break;
				default:
					live1frame_index = live1frame.length - 1; // 30 ips
					break;
			}
			break;
		case 5: // DR-4132P
			live2frame_index = live2frame.length - 2; // 15 ips

			switch (current_camera.model_group) {
				case 12: // 2MP camera
					live1frame_index = live1frame.length - 2; // 15 ips
					break;
				case 11: // 1MP camera
					live1frame_index = live1frame.length - 1; // 30 ips
					break;
				default:
					live1frame_index = live1frame.length - 1; // 30 ips
					break;
			}
			break;
		default: // 0
			live1frame_index = live1frame.length - 1; // 30 ips
			live2frame_index = live2frame.length - 1; // 30 ips
			break;
	} */

	live1frame.selectedIndex = live1frame_index;
	live2frame.selectedIndex = live2frame_index;
	remoteframe.selectedIndex = remoteframe.length - 4; // 5 ips
	timelapsframe.selectedIndex = live1frame_index; //timelapsframe.length -1;
	eventframe.selectedIndex = live1frame_index; //eventframe.length -1;

	live1quality.selectedIndex = live1quality.length -1;
	live2quality.selectedIndex = live2quality.length -1;
	remotequality.selectedIndex = remotequality.length -1;
	timelapsquality.selectedIndex = timelapsquality.length -1;
	eventquality.selectedIndex = eventquality.length -1;
	
	checkRealTimeMode();
	updateBandwidth();
}

/////////////////////////////////////////////////
//	Update Functions
////////////////////////////////////////////////

function updateBandwidth()
{
	var profileTypes = ["live1", "live2", "remote", "timelaps", "event"];
	var indexCamera = document.getElementById("select_camera_model").selectedIndex;
	var bandwidth;
	var profileBandwidth;

	if (g_isCustomCamera) {
		profileBandwidth = [g_current_camera_profile.live1_bitrate,
							g_current_camera_profile.live2_bitrate,
							g_current_camera_profile.remote_bitrate,
							g_current_camera_profile.timelaps_bitrate,
							g_current_camera_profile.event_bitrate];
	}

	for (i in profileTypes) {
		var ratio = 1;
		if (i == 3) {
			ratio = document.getElementById("check_use_timelaps").checked ? 1 : 0;
			if (document.getElementById("check_use_event").checked) {
				ratio = 1 - document.getElementById("input_event_ratio").value * 0.01;
			}
		}
		else if (i == 4)
			ratio = (document.getElementById("check_use_event").checked) ? document.getElementById("input_event_ratio").value * 0.01 : 0;
		
		if (g_isCustomCamera) {
			bandwidth = parseFloat(profileBandwidth[i]);
			document.getElementById("input_" + profileTypes[i] +"_bandwidth").value = g_unit.withUnit(bandwidth);
		}
		else {
			if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
				bandwidth = calculateAnalogBitrate(indexCamera, makeVideoProfile(profileTypes[i]), ratio, i);
			}
			else {
				bandwidth = calculateStreamBitrate(indexCamera, makeVideoProfile(profileTypes[i]), ratio, i);			
			}
			if(bandwidth == -1){
				document.getElementById("input_" + profileTypes[i] +"_bandwidth").value = "Not Support";
			}
			else {
				document.getElementById("input_" + profileTypes[i] +"_bandwidth").value = g_unit.withUnit(bandwidth);
			}
		}
	}
}

function makeCameraProfile()
{
	var cameraProfile = new CameraProfile();

	cameraProfile.camera_index 	= document.getElementById("select_camera_model").selectedIndex;
	cameraProfile.event_ratio 	= document.getElementById("check_use_event").checked ?
								  document.getElementById("input_event_ratio").value * 0.01 :
								  0;
	cameraProfile.camera_count 	= document.getElementById("select_camera_count").value;
	cameraProfile.audio_count 	= 0; //document.getElementById("input_audio_count").value; // explr

	cameraProfile.live1_profile  = makeVideoProfile("live1");
	cameraProfile.live2_profile  = makeVideoProfile("live2");
	cameraProfile.remote_profile = makeVideoProfile("remote");

	if (document.getElementById("check_use_timelaps").checked)
		cameraProfile.timelaps_video_profile 	= makeVideoProfile("timelaps");
	if (document.getElementById("check_use_event").checked)
		cameraProfile.event_video_profile 		= makeVideoProfile("event");

	return cameraProfile;
}
function makeVideoProfile(name)
{
	var videoProfile;
	var indexCodec, indexResolution, indexFramerate, indexQuality;

	indexCodec 		= document.getElementById("select_"+name+"_codec").selectedIndex;
	indexResolution = document.getElementById("select_"+name+"_resolution").selectedIndex;
	indexFramerate 	= document.getElementById("select_"+name+"_framerate").selectedIndex;
	indexQuality 	= document.getElementById("select_"+name+"_quality").selectedIndex;

	videoProfile = new VideoProfile(indexCodec, indexResolution, indexQuality, indexFramerate);

	return videoProfile;
}

//----------------------------------------------------
//	control event functions
//----------------------------------------------------
function useOnlyNumberKey(event)
{
	if (event.keyCode<48|| event.keyCode>57)
			event.returnValue=false;
}

function onChangeNVRModel()
{
	var index = document.getElementById("select_nvr_model").selectedIndex;
	if (index != null)
		g_current_nvr_model = g_nvr_device_list[index];

	// if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
		// document.getElementById("select_camera_model").disabled = true;
	// }
	// else {
		// document.getElementById("select_camera_model").disabled = false;
	// }
	
	initialize();
}

function onChangeHDDCapacity(obj)
{
}

function onChangeUnit()
{
	g_unit_selected	= document.getElementById("select_display_unit").selectedIndex;
	updateBandwidth();
	reflashSelectedCameraList();
}

function onChangeCameraModel(obj)
{
	if (!obj) {
		return;
	}

/*
	if (g_setting_mode == CAMERA_SETTTING_MODE_MODIFY) {
		if (obj.selectedIndex == g_camera_device_list.length) {
			if (g_modify_camera_profile.camera_index != -1) {
				obj.selectedIndex = g_modify_camera_profile.camera_index;
			}
		}
	}
*/
	g_current_camera_model = getCameraModel(obj.selectedIndex);
	
	if (g_current_camera_model.model_group == 100) {
		g_isCustomCamera = true;
		if (g_setting_mode != CAMERA_SETTTING_MODE_MODIFY) {
			setBandwidthZero();
		}
	}
	else {
		g_isCustomCamera = false;
		init_codecs();
		onChangeProfileCodec();
	}

	init_controls_enable();
	init_selectedIndex(); // explr

    // 각 프로파일에 대해서 모두 adjust를 실행한다.
    profile_adjust_function(document.getElementById("select_live1_resolution"));
    profile_adjust_function(document.getElementById("select_live2_resolution"));
    profile_adjust_function(document.getElementById("select_remote_resolution"));
    profile_adjust_function(document.getElementById("select_timelaps_resolution"));
    profile_adjust_function(document.getElementById("select_event_resolution"));
}

function getCameraModel(index)
{
	var list = new Array();

	for (x in g_camera_device_list) {
		if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
			if (g_camera_device_list[x].model_group == MODEL_GROUP_DVR) {
				list.push(g_camera_device_list[x]);
			}
		}
		else {
			if (g_camera_device_list[x].model_group != MODEL_GROUP_DVR) {
				list.push(g_camera_device_list[x]);
			}
		}
	}	
	
	return list[index];
}

function setBandwidthZero()
{
	document.getElementById("input_live1_bandwidth").value = 0;
	document.getElementById("input_live2_bandwidth").value = 0;
	document.getElementById("input_remote_bandwidth").value = 0;
	document.getElementById("input_timelaps_bandwidth").value = 0;
	document.getElementById("input_event_bandwidth").value = 0;

	updateBandwidth();
}


function findIndexOfText(elementId, findStr)
{
    var options = document.getElementById(elementId).options;
    
    for (var x = 0; x<options.length; x++) {
        if (options[x].text == findStr) {
            return parseInt(x);
        }
    }
}

function profile_adjust_function(control)
{
    var max_channel = g_current_nvr_model.directCameraCount;

    if (typeof control == 'undefined') return;

    var isFramerateEvent = control.attributes.id.value.indexOf("framerate") != -1;
	var isQualityEvent = control.attributes.id.value.indexOf("quality") != -1;
    if ((32 <= max_channel && g_current_nvr_model.model_group !=  MODEL_GROUP_EXXO) || g_current_nvr_model.nvr_name == "DR-2116P" || g_current_nvr_model.nvr_name == "DR-2216P") {
        // 32채널에서 제약되는 부분은 VMS에는 해당되지 않는다.
        if (g_current_nvr_model.model_group ==  MODEL_GROUP_VMS ||
            g_current_nvr_model.model_group ==  MODEL_GROUP_SPRATA||
			g_current_nvr_model.model_group == 8) {
            return;
        }
        {
            // live1
            var res_idx = document.getElementById("select_live1_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_live1_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_live1_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_live1_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_live1_quality").selectedIndex;
            
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
                if (isFramerateEvent) {
					document.getElementById("select_live1_quality").selectedIndex = 0;
                }
                else if (isQualityEvent && (quality > 0 )) {
                	var ips_15_idx =  findIndexOfText("select_live1_framerate", "15");                		
            		document.getElementById("select_live1_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_live1_quality").selectedIndex = 0;
                }
            }
        }
        
        {
            // live2
            var res_idx = document.getElementById("select_live2_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_live2_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_live2_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_live2_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_live2_quality").selectedIndex;
            
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
				if (isFramerateEvent) {
					document.getElementById("select_live2_quality").selectedIndex = 0;
                }
                else if (isQualityEvent && (quality > 0)) {
                	var ips_15_idx =  findIndexOfText("select_live2_framerate", "15");                		
            		document.getElementById("select_live2_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_live2_quality").selectedIndex = 0;
                }
            }
        }
        
        {
            // remote
            var res_idx = document.getElementById("select_remote_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_remote_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_remote_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_remote_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_remote_quality").selectedIndex;
            
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
                if (isFramerateEvent) {
					document.getElementById("select_remote_quality").selectedIndex = 0;
                }
               else if (isQualityEvent && (quality > 0)) {
                	var ips_15_idx =  findIndexOfText("select_remote_framerate", "15");                		
            		document.getElementById("select_remote_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_remote_quality").selectedIndex = 0;
                }
            }
        }
        
        {
            // record timelaps
            var res_idx = document.getElementById("select_timelaps_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_timelaps_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_timelaps_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_timelaps_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_timelaps_quality").selectedIndex;
            
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
                if (isFramerateEvent) {
					document.getElementById("select_timelaps_quality").selectedIndex = 0;
                }
                else if (isQualityEvent && (quality > 0)) {
                	var ips_15_idx =  findIndexOfText("select_timelaps_framerate", "15");                		
            		document.getElementById("select_timelaps_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_timelaps_quality").selectedIndex = 0;
                }
            }
        }
        
        {
            // record event
            var res_idx = document.getElementById("select_event_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_event_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_event_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_event_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_event_quality").selectedIndex;
            var ips_15_idx =  findIndexOfText("select_event_framerate", "15");                		
			
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
                if (isFramerateEvent) {
					document.getElementById("select_event_quality").selectedIndex = 0;
                }
                else if (isQualityEvent && (quality > 0)) {
            		document.getElementById("select_event_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_event_quality").selectedIndex = 0;
                }
            }
			
        }        
    }
	
	
	if(g_current_nvr_model.nvr_name == "DR-2116P")	{
        {
            // live1
            var res_idx = document.getElementById("select_live1_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_live1_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_live1_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_live1_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_live1_quality").selectedIndex;
            
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
                if (isFramerateEvent) {
					document.getElementById("select_live1_quality").selectedIndex = 1;
                }
                else if (isQualityEvent && (quality > 1 )) {
                	var ips_15_idx =  findIndexOfText("select_live1_framerate", "15");                		
            		document.getElementById("select_live1_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_live1_quality").selectedIndex = 1;
                }
            }
        }
        
        {
            // live2
            var res_idx = document.getElementById("select_live2_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_live2_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_live2_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_live2_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_live2_quality").selectedIndex;
            
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
				if (isFramerateEvent) {
					document.getElementById("select_live2_quality").selectedIndex = 1;
                }
                else if (isQualityEvent && (quality > 1)) {
                	var ips_15_idx =  findIndexOfText("select_live2_framerate", "15");                		
            		document.getElementById("select_live2_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_live2_quality").selectedIndex = 1;
                }
            }
        }
        
        {
            // remote
            var res_idx = document.getElementById("select_remote_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_remote_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_remote_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_remote_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_remote_quality").selectedIndex;
            
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
                if (isFramerateEvent) {
					document.getElementById("select_remote_quality").selectedIndex = 1;
                }
               else if (isQualityEvent && (quality > 1)) {
                	var ips_15_idx =  findIndexOfText("select_remote_framerate", "15");                		
            		document.getElementById("select_remote_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_remote_quality").selectedIndex = 1;
                }
            }
        }
        
        {
            // record timelaps
            var res_idx = document.getElementById("select_timelaps_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_timelaps_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_timelaps_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_timelaps_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_timelaps_quality").selectedIndex;
            
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
                if (isFramerateEvent) {
					document.getElementById("select_timelaps_quality").selectedIndex = 1;
                }
                else if (isQualityEvent && (quality > 1)) {
                	var ips_15_idx =  findIndexOfText("select_timelaps_framerate", "15");                		
            		document.getElementById("select_timelaps_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_timelaps_quality").selectedIndex = 1;
                }
            }
        }
        
        {
            // record event
            var res_idx = document.getElementById("select_event_resolution").selectedIndex;
            var res_1080_idx = findIndexOfText("select_event_resolution", "1920x1080");
            var framerate_idx = document.getElementById("select_event_framerate").selectedIndex;
            var framerate_str = document.getElementById("select_event_framerate").options[framerate_idx].text;
            var quality = document.getElementById("select_event_quality").selectedIndex;
            var ips_15_idx =  findIndexOfText("select_event_framerate", "15");                		
			
            if ((res_1080_idx <= res_idx) && (30 <= parseInt(framerate_str))) {
                if (isFramerateEvent) {
					document.getElementById("select_event_quality").selectedIndex = 1;
                }
                else if (isQualityEvent && (quality > 1)) {
            		document.getElementById("select_event_framerate").selectedIndex = ips_15_idx;
                }
                else {
					document.getElementById("select_event_quality").selectedIndex = 1;
                }
            }
			
        }  		
	}
	
	
	if(g_current_nvr_model.model_group == 14 || g_current_nvr_model.model_group == 15 || g_current_nvr_model.model_group == 16)	{
		{
			var res_idx = document.getElementById("select_live1_resolution").selectedIndex;
			var res_2160_idx = findIndexOfText("select_live1_resolution", "3840x2160");
			var framerate_idx = document.getElementById("select_live1_framerate").selectedIndex;
			var framerate_str = document.getElementById("select_live1_framerate").options[framerate_idx].text;
			var ips_15_idx =  findIndexOfText("select_live1_framerate", "15");
			if((res_2160_idx <= res_idx) && (15 < parseInt(framerate_str)))	{
				document.getElementById("select_live1_framerate").selectedIndex = ips_15_idx;
			}
		}

		{
			var res_idx = document.getElementById("select_live2_resolution").selectedIndex;
			var res_2160_idx = findIndexOfText("select_live2_resolution", "3840x2160");
			var framerate_idx = document.getElementById("select_live2_framerate").selectedIndex;
			var framerate_str = document.getElementById("select_live2_framerate").options[framerate_idx].text;
			var ips_15_idx =  findIndexOfText("select_live2_framerate", "15");
			if((res_2160_idx <= res_idx) && (15 < parseInt(framerate_str)))	{
				document.getElementById("select_live2_framerate").selectedIndex = ips_15_idx;
			}
		}

		{
			var res_idx = document.getElementById("select_remote_resolution").selectedIndex;
			var res_2160_idx = findIndexOfText("select_remote_resolution", "3840x2160");
			var framerate_idx = document.getElementById("select_remote_framerate").selectedIndex;
			var framerate_str = document.getElementById("select_remote_framerate").options[framerate_idx].text;
			var ips_15_idx =  findIndexOfText("select_remote_framerate", "15");
			if((res_2160_idx <= res_idx) && (15 < parseInt(framerate_str)))	{
				document.getElementById("select_remote_framerate").selectedIndex = ips_15_idx;
			}
		}

		{
			var res_idx = document.getElementById("select_timelaps_resolution").selectedIndex;
			var res_2160_idx = findIndexOfText("select_timelaps_resolution", "3840x2160");
			var framerate_idx = document.getElementById("select_timelaps_framerate").selectedIndex;
			var framerate_str = document.getElementById("select_timelaps_framerate").options[framerate_idx].text;
			var ips_15_idx =  findIndexOfText("select_timelaps_framerate", "15");
			if((res_2160_idx <= res_idx) && (15 < parseInt(framerate_str)))	{
				document.getElementById("select_timelaps_framerate").selectedIndex = ips_15_idx;
			}
		}

		{
			var res_idx = document.getElementById("select_event_resolution").selectedIndex;
			var res_2160_idx = findIndexOfText("select_event_resolution", "3840x2160");
			var framerate_idx = document.getElementById("select_event_framerate").selectedIndex;
			var framerate_str = document.getElementById("select_event_framerate").options[framerate_idx].text;
			var ips_15_idx =  findIndexOfText("select_event_framerate", "15");
			if((res_2160_idx <= res_idx) && (15 < parseInt(framerate_str)))	{
				document.getElementById("select_event_framerate").selectedIndex = ips_15_idx;
			}
		}
	}
}

function onChangeProfileCodec()
{
	//reInitOtherControls
	init_camera_profile("live1");
	init_camera_profile("live2");
	init_camera_profile("remote");
	init_camera_profile("timelaps");
	init_camera_profile("event");
	init_selectedIndex();

	onChangeProfileOptions();
}

function onChangeProfileOptions(control)
{
    profile_adjust_function(control);
    
	var profileTypes = ["live1", "live2", "remote"];

	if (document.getElementById("check_use_timelaps").checked) {
		profileTypes.push("timelaps");
	}
	if (document.getElementById("check_use_event").checked) {
		profileTypes.push("event");
	}
	//Update BandsWidth();
	for (x in profileTypes) {
		resetFrameRate(profileTypes[x]);
		
		if (x == 0) checkRealTimeMode();
	}
	updateBandwidth();
}

function resetFrameRate(name)
{
	var selectedCamera = document.getElementById("select_camera_model").selectedIndex;
	var selectedNvr = document.getElementById("select_nvr_model").selectedIndex;
	
	var index = document.getElementById("select_"+name+"_codec").selectedIndex;
	var current_camera = g_current_camera_model;

	var codec = current_camera.codec_list[index];
	var ips_limit = g_nvr_device_list[selectedNvr].max_record_ips;
	
	var resIndex = document.getElementById("select_" + name + "_resolution").selectedIndex;
	var res = document.getElementById("select_" + name + "_resolution").item(resIndex).text;
	var sel = document.getElementById("select_" + name + "_framerate").selectedIndex;
	
	var framerate_list = codec.support_framerate_list;
	if (g_current_nvr_model.model_group == MODEL_GROUP_DVR &&
		 codec.resolution_factor_list[0] == 3) { 
			if (g_current_nvr_model.max_record_ips[3] == 10) {
				framerate_list = [1, 2, 3, 4, 5, 10];
			}
			else if (g_current_nvr_model.max_record_ips[3] == 15) {
				framerate_list = [1, 2, 3, 4, 5, 10, 15];
			}
	}
    
    // VMS를 제외한 현재 NVR에서는 60ips를 지원하지 않는다.
    if (g_current_nvr_model.model_group !=  MODEL_GROUP_VMS) {
        var index = framerate_list.indexOf(60);
        if (0 < index) {
            framerate_list = framerate_list.slice(0, index);
        }
    }
	
	replaceList("select_" + name + "_framerate",  framerate_list);
	var frameRateSize =  document.getElementById("select_" + name + "_framerate").length;
	if(g_current_nvr_model.model_group < 11)	{
		if (res == "2304x1296" || res == "2048x1536" || res == "3840x2160") {
			if(g_current_camera_model.model_name != "DC-B3303X")	{
				var element = document.getElementById("select_" + name + "_framerate"); 
				var child = element.item(frameRateSize - 1);
				element.removeChild(child);
				
				if (frameRateSize -1 <= sel)  {
					document.getElementById("select_" + name + "_framerate").selectedIndex = frameRateSize - 2;
				}
			}
		}
		else {
			document.getElementById("select_" + name + "_framerate").selectedIndex = sel;
		}
	}
	else if(g_current_nvr_model.model_group >13 )	{
		if (res == "3840x2160") {
			var element = document.getElementById("select_" + name + "_framerate"); 
			var child = element.item(frameRateSize - 1);
			element.removeChild(child);
			
			if (frameRateSize -1 <= sel)  {
				document.getElementById("select_" + name + "_framerate").selectedIndex = frameRateSize - 2;
			}
		}
		else {
			document.getElementById("select_" + name + "_framerate").selectedIndex = sel;
		}		
	}
}

function onSelectBandwidthControl()
{
	if (g_isCustomCamera) {
		document.getElementById("input_live1_bandwidth").value = g_unit.withUnit(g_current_camera_profile.live1_bitrate);
		document.getElementById("input_live2_bandwidth").value = g_unit.withUnit(g_current_camera_profile.live2_bitrate);
		document.getElementById("input_remote_bandwidth").value = g_unit.withUnit(g_current_camera_profile.remote_bitrate);
		document.getElementById("input_timelaps_bandwidth").value = g_unit.withUnit(g_current_camera_profile.timelaps_bitrate);
		document.getElementById("input_event_bandwidth").value = g_unit.withUnit(g_current_camera_profile.event_bitrate);
	}
	else {
		document.getElementById("input_live1_bandwidth").value = g_current_camera_profile.live1_bitrate;
		document.getElementById("input_live2_bandwidth").value = g_current_camera_profile.live2_bitrate;
		document.getElementById("input_remote_bandwidth").value = g_current_camera_profile.remote_bitrate;
		document.getElementById("input_timelaps_bandwidth").value = g_current_camera_profile.timelaps_bitrate;
		document.getElementById("input_event_bandwidth").value = g_current_camera_profile.event_bitrate;
	}
}

function onChangeBandwidth()
{
	// value unit = Kbps
	if (g_isCustomCamera) {
		g_current_camera_profile.live1_bitrate = g_unit.changeOtherUnit(parseFloat(document.getElementById("input_live1_bandwidth").value), 1);
		g_current_camera_profile.live2_bitrate = g_unit.changeOtherUnit(parseFloat(document.getElementById("input_live2_bandwidth").value), 1);
		g_current_camera_profile.remote_bitrate = g_unit.changeOtherUnit(parseFloat(document.getElementById("input_remote_bandwidth").value), 1);
		g_current_camera_profile.timelaps_bitrate = g_unit.changeOtherUnit(parseFloat(document.getElementById("input_timelaps_bandwidth").value), 1);
		g_current_camera_profile.event_bitrate = g_unit.changeOtherUnit(parseFloat(document.getElementById("input_event_bandwidth").value), 1);
	}
	else {
		g_current_camera_profile.live1_bitrate = parseFloat(document.getElementById("input_live1_bandwidth").value);
		g_current_camera_profile.live2_bitrate = parseFloat(document.getElementById("input_live2_bandwidth").value);
		g_current_camera_profile.remote_bitrate = parseFloat(document.getElementById("input_remote_bandwidth").value);
		g_current_camera_profile.timelaps_bitrate = parseFloat(document.getElementById("input_timelaps_bandwidth").value);
		g_current_camera_profile.event_bitrate = parseFloat(document.getElementById("input_event_bandwidth").value);

		updateBandwidth();
	}
}

function onChangeHddCapacity(select)
{
	g_current_hdd_size = g_hdd_list[select.selectedIndex];
	reflashResult();
}

function onChangeEventRatio(input)
{
	var value = Number(input.value);
	if (value < 0) {
		input.value = 0;
	}
	else if (100 < value) {
		input.value = 100;
	}

	updateBandwidth();
}

function onChangeCameraCount(input)
{
/*	if (input.id == "input_audio_count") {
		var maxValue = document.getElementById("select_camera_count").value;
		if (Number(maxValue) < Number(input.value)) {
			input.value = maxValue;
		}
	}
	else {
		document.getElementById("input_audio_count").value = input.value;
	}
*/
}

function onClickRecordProfileCheck(checkbox)
{
	if (checkbox.value == "timelaps") {
		document.getElementById("select_timelaps_codec").disabled = !checkbox.checked || g_isCustomCamera;
		document.getElementById("select_timelaps_resolution").disabled = !checkbox.checked || g_isCustomCamera;
		document.getElementById("select_timelaps_framerate").disabled = !checkbox.checked || g_isCustomCamera;
		document.getElementById("select_timelaps_quality").disabled = !checkbox.checked || g_isCustomCamera;
		document.getElementById("input_timelaps_bandwidth").disabled = !checkbox.checked || !g_isCustomCamera;
		if (!checkbox.checked && g_isCustomCamera) {
			g_current_camera_profile.timelaps_bitrate = 0;
		}
	}
	else {
		document.getElementById("select_event_codec").disabled = !checkbox.checked || g_isCustomCamera;
		document.getElementById("select_event_resolution").disabled = !checkbox.checked || g_isCustomCamera;
		document.getElementById("select_event_framerate").disabled = !checkbox.checked || g_isCustomCamera;
		document.getElementById("select_event_quality").disabled = !checkbox.checked || g_isCustomCamera;
		document.getElementById("input_event_bandwidth").disabled = !checkbox.checked || !g_isCustomCamera;
		document.getElementById("input_event_ratio").disabled = !checkbox.checked || g_isCustomCamera;
		if (!checkbox.checked && g_isCustomCamera) {
			g_current_camera_profile.event_bitrate = 0;
		}
	}

	updateBandwidth();
}

function onClickDetailSettingButton()
{
	if (g_detail_layout_status == HIDE_DETAIL_LAYOUT) {
		document.getElementById("layer_camera_detail_setting").style.display = "block";
		//버튼의 이미지를 상단방향 화살표로 바꾸어 준다.
		if (BUILD_TYPE == "BRAND_ONLINE") {
			document.getElementById("toogle_detail_setting_button").innerHTML = "<img src='/resources/img/bandwidth/triangle_up.png'>";
		}
		else {
			document.getElementById("layer_container").style.height = 1100;
			if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
				document.getElementById("layer_setting").style.height = 692 - 150;
			}
			else {
				document.getElementById("layer_setting").style.height = 692;
			}
			document.getElementById("toogle_detail_setting_button").innerHTML = "<img src='CapEst_Files/triangle_up.png'>";
		}
		g_detail_layout_status = SHOW_DETAIL_LAYOUT;
		//g_setting_mode = CAMERA_SETTTING_MODE_MODIFY;
	}
	else {
		document.getElementById("layer_camera_detail_setting").style.display = "none";
		if (BUILD_TYPE == "BRAND_ONLINE") {
			document.getElementById("toogle_detail_setting_button").innerHTML = "<img src='/resources/img/bandwidth/triangle_down.png'>"
		}
		else {
			document.getElementById("layer_container").style.height = 1100 - 395;
			document.getElementById("layer_setting").style.height = 692 - 395;
			document.getElementById("toogle_detail_setting_button").innerHTML = "<img src='CapEst_Files/triangle_down.png'>"
		}
		//버튼의 이미지를 하단방향 화살표로 바꾸어 준다.
		g_detail_layout_status = HIDE_DETAIL_LAYOUT;
		document.getElementById("inset_camera").disabled = false;
		document.getElementById("toogle_detail_setting_button").disabled = false;
		//g_setting_mode = CAMERA_SETTTING_MODE_INSERT;
	}
}

function onClickInsertCameraProfile()
{
	g_setting_mode = CAMERA_SETTTING_MODE_INSERT;
	var cameraProfile;
	var cameraCount = 0;

	cameraCount = Number(document.getElementById("select_camera_count").value);
	var totalCount = cameraCount;
	for (x in g_camera_profile_list) {
		totalCount += Number(g_camera_profile_list[x].camera_count);
	}

	if (cameraCount < 1 || totalCount   > g_current_nvr_model.directCameraCount) {
			alert("Error in Number of Camera Control");
			return;
	}

	if (g_isCustomCamera) {
        onChangeBandwidth();
		cameraProfile = g_current_camera_profile;
		cameraProfile.camera_index = -1;
		cameraProfile.camera_count = Number(document.getElementById("select_camera_count").value);
		cameraProfile.audio_count = 0; //Number(document.getElementById("input_audio_count").value); // explr
		cameraProfile.event_ratio	= Number(document.getElementById("input_event_ratio").value) / 100;
        cameraProfile.timelaps_bitrate *= cameraProfile.camera_count;
        cameraProfile.event_bitrate *= cameraProfile.camera_count;
		g_current_camera_profile = new CameraProfile();
		g_current_camera_profile.isCustomCamera = true;
	}
	else {
		cameraProfile = makeCameraProfile();
		if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
			cameraProfile.calculateAnalog();
			cameraProfile.remote_bitrate 	= 0;
			cameraProfile.live1_bitrate = 0;
			cameraProfile.live2_bitrate = 0;
		}
		else {
			cameraProfile.calculatethis();		
		}
	}

	g_camera_profile_list.push(cameraProfile);

	//Update UI

	if(reflashSelectedCameraList())
		reflashResult();
}

function onClickDelteCameraProfile(row)
{
	var index = -1;
	var table = document.getElementById("camera_table");

	row = row.parentElement.parentElement;

	for (var x=0; x < table.rows.length; x++) {
		if (table.rows[x] == row) {
			index = x;
			break;
		}
	}

	if (g_setting_mode == CAMERA_SETTTING_MODE_MODIFY &&
		g_camera_profile_list[index] == g_modify_camera_profile) {
		onClickModifySumit();
	}
	g_camera_profile_list.splice(index, 1);
	reflashSelectedCameraList();
	reflashResult();
}

function onClickModifyCameraProfile(row)
{
	var index = -1;
	var table = document.getElementById("camera_table");

	row = row.parentElement.parentElement;

	for (var x=0; x<table.rows.length; x++) {
		if (table.rows[x] == row) {
			index = x;
			break;
		}
	}
	g_modify_index = index;
	g_modify_camera_profile = clone(g_camera_profile_list[index], g_modify_camera_profile);
	//g_detail_layout_status = HIDE_DETAIL_LAYOUT; // explr
	setUIProfileSetting(g_modify_camera_profile);
	onClickDetailSettingButton();
	onChangeProfileOptions();
}

function setUIProfileSetting(cameraProfile)
{
	document.getElementById("select_camera_model").selectedIndex 		= cameraProfile.camera_index;

	onChangeCameraModel(document.getElementById("select_camera_model"));
	document.getElementById("select_camera_count").value				= cameraProfile.camera_count;
	document.getElementById("input_event_ratio").value					= cameraProfile.event_ratio * 100;
	//document.getElementById("input_audio_count").value 					= cameraProfile.audio_count; // explr

	document.getElementById("select_live1_codec").selectedIndex 		= cameraProfile.live1_profile.selected_codec_index;
	document.getElementById("select_live1_resolution").selectedIndex 	= cameraProfile.live1_profile.selected_resolution_index;
	document.getElementById("select_live1_framerate").selectedIndex 	= cameraProfile.live1_profile.selected_framerate_index;
	document.getElementById("select_live1_quality").selectedIndex 		= cameraProfile.live1_profile.selected_quality_index;

	document.getElementById("select_live2_codec").selectedIndex 		= cameraProfile.live2_profile.selected_codec_index;
	document.getElementById("select_live2_resolution").selectedIndex 	= cameraProfile.live2_profile.selected_resolution_index;
	document.getElementById("select_live2_framerate").selectedIndex 	= cameraProfile.live2_profile.selected_framerate_index;
	document.getElementById("select_live2_quality").selectedIndex 		= cameraProfile.live2_profile.selected_quality_index;

	document.getElementById("select_remote_codec").selectedIndex 		= cameraProfile.remote_profile.selected_codec_index;
	document.getElementById("select_remote_resolution").selectedIndex 	= cameraProfile.remote_profile.selected_resolution_index;
	document.getElementById("select_remote_framerate").selectedIndex 	= cameraProfile.remote_profile.selected_framerate_index;
	document.getElementById("select_remote_quality").selectedIndex 		= cameraProfile.remote_profile.selected_quality_index;

	if (cameraProfile.timelaps_video_profile) {
		document.getElementById("select_timelaps_codec").selectedIndex 		= cameraProfile.timelaps_video_profile.selected_codec_index;
		document.getElementById("select_timelaps_resolution").selectedIndex = cameraProfile.timelaps_video_profile.selected_resolution_index;
		document.getElementById("select_timelaps_framerate").selectedIndex 	= cameraProfile.timelaps_video_profile.selected_framerate_index;
		document.getElementById("select_timelaps_quality").selectedIndex 	= cameraProfile.timelaps_video_profile.selected_quality_index;
		document.getElementById("check_use_timelaps").checked 				= true;
	}
	else {
		document.getElementById("check_use_timelaps").checked 				= false;
	}

	if (cameraProfile.event_video_profile) {
		document.getElementById("select_event_codec").selectedIndex 		= cameraProfile.event_video_profile.selected_codec_index;
		document.getElementById("select_event_resolution").selectedIndex 	= cameraProfile.event_video_profile.selected_resolution_index;
		document.getElementById("select_event_framerate").selectedIndex 	= cameraProfile.event_video_profile.selected_framerate_index;
		document.getElementById("select_event_quality").selectedIndex 		= cameraProfile.event_video_profile.selected_quality_index;
		document.getElementById("check_use_event").checked 					= true;
	}
	else {
		document.getElementById("check_use_event").checked 					= false;
	}

	onClickRecordProfileCheck(document.getElementById("check_use_timelaps"));
	onClickRecordProfileCheck(document.getElementById("check_use_event"));

	document.getElementById("submit_modify").style.display = "block";
	document.getElementById("inset_camera").disabled = true;
	document.getElementById("toogle_detail_setting_button").disabled = true;
}

function onClickModifySumit()
{
	g_setting_mode = CAMERA_SETTTING_MODE_MODIFY;
	g_detail_layout_status = SHOW_DETAIL_LAYOUT;
	g_before_modify_camera_profile = clone(g_modify_camera_profile, g_before_modify_camera_profile);
	setCameraProfileSetting(g_modify_camera_profile);
	g_camera_profile_list[g_modify_index] = clone(g_modify_camera_profile, g_camera_profile_list[g_modify_index]);
	
	if (document.getElementById("check_use_timelaps").checked) {
		if (!(document.getElementById("check_use_event").checked)) {
			g_modify_camera_profile.event_ratio = 0;
		}
	}

	if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
		g_modify_camera_profile.calculateAnalog();
		g_modify_camera_profile.remote_bitrate 	= 0;
		g_modify_camera_profile.live1_bitrate = 0;
		g_modify_camera_profile.live2_bitrate = 0;
		g_camera_profile_list[g_modify_index] = clone(g_modify_camera_profile, g_camera_profile_list[g_modify_index]);
	}
	else {
		g_camera_profile_list[g_modify_index].calculatethis();
		//g_modify_camera_profile.calculatethis();
	}
	onClickDetailSettingButton();
	reflashSelectedCameraList();
	reflashResult();
}

function setCameraProfileSetting(cameraProfile)
{
	cameraProfile.camera_index = document.getElementById("select_camera_model").selectedIndex;
	cameraProfile.camera_count = Number(document.getElementById("select_camera_count").value);
	cameraProfile.event_ratio = Number(document.getElementById("input_event_ratio").value) * 0.01;
	cameraProfile.audio_count = 0; //Number(document.getElementById("input_audio_count").value); // explr

	cameraProfile.live1_profile.selected_codec_index = document.getElementById("select_live1_codec").selectedIndex;
	cameraProfile.live1_profile.selected_resolution_index = document.getElementById("select_live1_resolution").selectedIndex;
	cameraProfile.live1_profile.selected_framerate_index = document.getElementById("select_live1_framerate").selectedIndex;
	cameraProfile.live1_profile.selected_quality_index = document.getElementById("select_live1_quality").selectedIndex;

	cameraProfile.live2_profile.selected_codec_index = document.getElementById("select_live2_codec").selectedIndex;
	cameraProfile.live2_profile.selected_resolution_index = document.getElementById("select_live2_resolution").selectedIndex;
	cameraProfile.live2_profile.selected_framerate_index = document.getElementById("select_live2_framerate").selectedIndex;
	cameraProfile.live2_profile.selected_quality_index = document.getElementById("select_live2_quality").selectedIndex;

	cameraProfile.remote_profile.selected_codec_index = document.getElementById("select_remote_codec").selectedIndex;
	cameraProfile.remote_profile.selected_resolution_index = document.getElementById("select_remote_resolution").selectedIndex;
	cameraProfile.remote_profile.selected_framerate_index = document.getElementById("select_remote_framerate").selectedIndex;
	cameraProfile.remote_profile.selected_quality_index = document.getElementById("select_remote_quality").selectedIndex;

	if (document.getElementById("check_use_timelaps").checked) {
		if (!cameraProfile.timelaps_video_profile)
			cameraProfile.timelaps_video_profile = new VideoProfile();
		cameraProfile.timelaps_video_profile.selected_codec_index = document.getElementById("select_timelaps_codec").selectedIndex;
		cameraProfile.timelaps_video_profile.selected_resolution_index = document.getElementById("select_timelaps_resolution").selectedIndex;
		cameraProfile.timelaps_video_profile.selected_framerate_index = document.getElementById("select_timelaps_framerate").selectedIndex;
		cameraProfile.timelaps_video_profile.selected_quality_index = document.getElementById("select_timelaps_quality").selectedIndex;
	}
	else {
		cameraProfile.timelaps_video_profile = null;
	}

	if (document.getElementById("check_use_event").checked) {
		if (!cameraProfile.event_video_profile)
			cameraProfile.event_video_profile = new VideoProfile();
		cameraProfile.event_video_profile.selected_codec_index = document.getElementById("select_event_codec").selectedIndex;
		cameraProfile.event_video_profile.selected_resolution_index = document.getElementById("select_event_resolution").selectedIndex;
		cameraProfile.event_video_profile.selected_framerate_index = document.getElementById("select_event_framerate").selectedIndex;
		cameraProfile.event_video_profile.selected_quality_index = document.getElementById("select_event_quality").selectedIndex;

	}
	else {
		cameraProfile.event_video_profile = null;
	}

	document.getElementById("submit_modify").style.display = "none";
	document.getElementById("inset_camera").disabled = false;
	document.getElementById("toogle_detail_setting_button").disabled = false;

}

function onClickSetRecordDuration()
{
	reflashRequiredDiskCapacity();
}

function onClickSetDiskCapacity()
{
	reflashRecordableTimeLength();
}

function onChangeHddRaid()
{
    var item = document.getElementById("select_hdd_raid");
    var index = item.selectedIndex;
    g_hdd_raid_mode = parseInt(item.options[index].value);
    
    console.log("mode changed" + g_hdd_raid_mode);
    
    reflashRequiredDiskCapacity();
    reflashRecordableTimeLength();
}

function changeResult(obj)
{
	if (obj.id == "disk_capacity") {
		document.getElementById("disk_capacity").className = "tab_layer";
		document.getElementById("time_length").className = "disable_tab_layer";
		document.getElementById("layer_capacity_result").style.display = "block";
		document.getElementById("layer_time_length_result").style.display = "none";

		document.getElementById("check_use_record_duration").disabled 	= false;
		document.getElementById("record_duration_value").disabled 		= false;
		document.getElementById("record_duration_unit").disabled 		= false;
		document.getElementById("check_use_disk_capacity").disabled 	= true;
		document.getElementById("disk_capacity_value").disabled 		= true;

		reflashResult();
	}
	else {
		document.getElementById("disk_capacity").className = "disable_tab_layer";
		document.getElementById("time_length").className = "tab_layer";
		document.getElementById("layer_capacity_result").style.display = "none";
		document.getElementById("layer_time_length_result").style.display = "block";

		document.getElementById("check_use_record_duration").disabled 	= true;
		document.getElementById("record_duration_value").disabled 		= true;
		document.getElementById("record_duration_unit").disabled 		= true;
		document.getElementById("check_use_disk_capacity").disabled 	= false;
		document.getElementById("disk_capacity_value").disabled 		= false;

		reflashResult();
	}
}

function clearSelectedCameraList()
{
	var table = document.getElementById("camera_table");

	g_detail_layout_status = SHOW_DETAIL_LAYOUT;
	onClickDetailSettingButton();

	for (i = table.rows.length; i > 0 ; i--) {
		g_camera_profile_list.splice(i - 1, 1);
	}
	reflashSelectedCameraList();
	reflashResult();
}

function findAnalogCamera(index)
{
	var models = document.getElementById("select_camera_model");
	var name = models.options[index].text;
	
	return name;
}

function reflashSelectedCameraList()
{
	var table = document.getElementById("camera_table");

	var totalCameraCount = 0;
	var totalLiveBandwidth = 0;
	var totalRecordingBandwidth = 0;
	var totalRemoteBandwidth = 0;
	var totalBandwidth = 0;

	while (table.rows[0]) {
		table.deleteRow(0);
	}

	for ( x in g_camera_profile_list) {
		var profiles = g_camera_profile_list[x];
		var row = table.insertRow(table.rows.length);
		var name;
		var deleteForm = "";

		if (profiles.camera_index < 0)
			name = "Custom Camera";
		else if (g_current_nvr_model.model_group == MODEL_GROUP_DVR) {
			name = findAnalogCamera(profiles.camera_index);
		}
		else 
			name = g_camera_device_list[profiles.camera_index].model_name;

		var liveBitrate = profiles.live1_bitrate;// + profiles.live2_bitrate;
		var remoteBitrate = profiles.remote_bitrate;
		var recordBitrate = profiles.timelaps_bitrate + profiles.event_bitrate;
		//check limit bitrate one camera model
/*		if (g_current_nvr_model.max_total_live_bitrate < liveBitrate) {
			liveBitrate = g_current_nvr_model.max_total_live_bitrate;
		}*/
		
		if (g_current_nvr_model.max_total_live_bitrate < totalRecordingBandwidth + recordBitrate) {
			alert("Maximum of Recording throughput is exceeded. You need to set lower than that.");
			if(g_setting_mode == CAMERA_SETTTING_MODE_MODIFY)	{
					g_camera_profile_list[g_modify_index] = clone(g_before_modify_camera_profile, g_camera_profile_list[g_modify_index]);
					g_modify_camera_profile = clone(g_before_modify_camera_profile, g_modify_camera_profile);
					reflashSelectedCameraList();
					return false;
			}
			else	{
				g_camera_profile_list.pop();
				return false;
			}
			//recordBitrate = g_current_nvr_model.max_total_live_bitrate;
		}
		
		if (g_current_nvr_model.max_total_remote_bitrate < remoteBitrate) {
			g_camera_profile_list.pop();
			return false;
			remoteBitrate= g_current_nvr_model.max_total_remote_bitrate;
		}
		
/*		if (g_current_nvr_model.max_total_live_bitrate < liveBitrate) {
			liveBitrate = g_current_nvr_model.max_total_live_bitrate;
		}		*/
		
/*		if (g_current_nvr_model.max_live_bitrate < liveBitrate) { // explr (2013.10.08)
			liveBitrate = g_current_nvr_model.max_live_bitrate;
		}
		if (g_current_nvr_model.max_remote_bitrate < remoteBitrate) {
			remoteBitrate = g_current_nvr_model.max_remote_bitrate;
		}*/

		//var totalBitrate = profiles.getTotalBitrate();
		var totalBitrate = liveBitrate + recordBitrate + remoteBitrate;

		row.insertCell(0).innerHTML = name;
		row.insertCell(1).innerHTML = profiles.camera_count;
		row.insertCell(2).innerHTML = g_unit.withUnit(recordBitrate);
		row.insertCell(3).innerHTML = g_unit.withUnit(liveBitrate);
		row.insertCell(4).innerHTML = g_unit.withUnit(remoteBitrate);
		row.insertCell(5).innerHTML = g_unit.withUnit(totalBitrate);

		if (profiles.camera_index != -1)
			deleteForm = "<button onclick='onClickModifyCameraProfile(this)'>M</button>";
		row.insertCell(6).innerHTML = deleteForm + "<button onclick='onClickDelteCameraProfile(this)'>x</button>";

		if (BUILD_TYPE == "BRAND_ONLINE") {
			row.cells[0].width = "18%"
			row.cells[1].width = "10%"
			row.cells[2].width = "15%"
			row.cells[3].width = "15%"
			row.cells[4].width = "15%"
			row.cells[5].width = "15%"
			row.cells[6].width = "12%"
		}
		else {
			row.cells[0].width = "138px"
			row.cells[1].width = "80px"
			row.cells[2].width = "115px"
			row.cells[3].width = "115px"
			row.cells[4].width = "115px"
			row.cells[5].width = "115px"
			row.cells[6].width = "75px"
		}

		for( x in row.cells) {
			row.cells[x].align="center";
		}

		totalCameraCount += Number(profiles.camera_count);
		totalLiveBandwidth += liveBitrate; //profiles.live1_bitrate + profiles.live2_bitrate;
		totalRecordingBandwidth += profiles.timelaps_bitrate + profiles.event_bitrate;
		totalRemoteBandwidth += remoteBitrate;
	}

	//check limit bitrate total nvr cameras
/*	if (g_current_nvr_model.max_total_live_bitrate < totalLiveBandwidth) {
		totalLiveBandwidth = g_current_nvr_model.max_total_live_bitrate;
	}*/
	if (g_current_nvr_model.max_total_live_bitrate < totalRecordingBandwidth) {
		//totalRecordingBandwidth = g_current_nvr_model.max_total_live_bitrate;
		return false;
	}
	if (g_current_nvr_model.max_total_remote_bitrate < totalRemoteBandwidth) {
		//totalRemoteBandwidth = g_current_nvr_model.max_total_remote_bitrate;
		return false;
	}
	

	totalBandwidth = totalLiveBandwidth + totalRecordingBandwidth + totalRemoteBandwidth;

	document.getElementById("total_camera_count").innerHTML		= totalCameraCount;
	document.getElementById("total_live_bandwidth").innerHTML	= g_unit.withUnit(totalLiveBandwidth);
	document.getElementById("total_record_bandwidth").innerHTML	= g_unit.withUnit(totalRecordingBandwidth);
	document.getElementById("total_remote_bandwidth").innerHTML	= g_unit.withUnit(totalRemoteBandwidth);
	document.getElementById("total_bandwidth").innerHTML		= g_unit.withUnit(totalBandwidth);
	
	return true;
}

function reflashRequiredDiskCapacity()
{
	var durations = ["1 Hour", "1 Day", "1 Month"];
	var duration_per_hour = [1, 24, 24 * 31, 24 * 31 * 12];
	var table = document.getElementById("capacity_result_table");

	if (document.getElementById("check_use_record_duration").checked) {
		var durationNum = Number(document.getElementById("record_duration_value").value);
		var units = document.getElementById("record_duration_unit");

		durations = new Array();
		durations.push(durationNum + " " + units.options[units.selectedIndex].value);

		var base = duration_per_hour[units.selectedIndex];
		duration_per_hour = new Array();
		duration_per_hour.push(base* durationNum);
	}

	var row1 = table.rows[0];
	var row2 = table.rows[1];

	while(row1.cells[1]) {
		row1.deleteCell(-1);	//row1.cells[1].remove(); // explr
	}
	while(row2.cells[1]) {
		row2.deleteCell(-1);	//row2.cells[1].remove();
	}
	for (x in durations) {
		var cell1= row1.insertCell(-1);
		var cell2 = row2.insertCell(-1);

		if (durations.length < 3) {
			cell1.colSpan = 3;
		}
		if (durations.length < 3) {
			cell2.colSpan = 3;
		}

		cell1.style.width = "14.5%";
		cell2.style.width = "14.5%";
		cell1.align = "center";
		cell2.align = "center";
		//cell2.bgColor = "#FFF";
		cell2.style.backgroundColor = "White"; //explr
		var kbps = requiredDiskCapacity(duration_per_hour[x] * 60 * 60);
		cell1.innerText = durations[x];
		cell2.innerText = g_unit.withFitUnit(kbps);
	}
}

function reflashRecordableTimeLength()
{
	var diskCapacity = [g_current_hdd_size];
	var table = document.getElementById("time_length_result_table");

	if (document.getElementById("check_use_disk_capacity").checked) {
		var capacity = Number(document.getElementById("disk_capacity_value").value);
		var capacity_unit = document.getElementById("disk_capacity_unit").selectedIndex;
		diskCapacity = new Array();
		if (capacity_unit == 0) {
			capacity = capacity * 1024;
		}

		diskCapacity.push(capacity);
	}

	while(table.rows[1]) {
		table.deleteRow(1);
	}

	for (x in diskCapacity) {
		var row = table.insertRow(table.rows.length);
		row.align = "center";
		var recordingTime = recordableTimeLength(diskCapacity[x]);

		var capacity_bit = diskCapacity[x] * 1024 *1024 * 8 ;
		row.insertCell(0).innerHTML = g_unit.withFitUnit(capacity_bit);
		row.insertCell(1).innerHTML = addNumCommas(Math.round(recordingTime / (60 * 60) * 10) / 10);
		row.insertCell(2).innerHTML = addNumCommas(Math.round(recordingTime / (60 * 60 * 24) * 10) / 10);
		row.insertCell(3).innerHTML = addNumCommas(Math.round(recordingTime / (60 * 60 * 24 * 30) * 10) / 10);
		// row.insertCell(4).innerHTML = claculateNVRRequiredUsingBitrate();
	}
}

function reflashResult()
{
	reflashRequiredDiskCapacity();
	reflashRecordableTimeLength();
}

function checkRealTimeMode()
{
	//check live1
	var resolution = document.getElementById("select_live1_resolution");
	var framerate = document.getElementById("select_live1_framerate");
	if  (resolution.value == "1920x1080" || resolution.value == "2048*1536" &&
		framerate.value == 30) {
		var quality = document.getElementById("select_live1_quality");
		if (g_current_nvr_model.nvr_name == "DR-2208P" ||
			g_current_nvr_model.nvr_name == "DR-2216P") { 
			if (1 < quality.selectedIndex)  quality.selectedIndex = 1;
		}
		/*else if (g_current_nvr_model.nvr_name == "DR-6232(PS/PS-S/P/P-S)") {	
			if (0 < quality.selectedIndex)  quality.selectedIndex = 0;
			resolution = document.getElementById("select_live1_resolution");
			quality = document.getElementById("select_live1_quality");
			framerate = document.getElementById("select_live1_framerate");
			resolution.selectedIndex = 1;
			quality.selectedIndex = 1;
			framerate.selectedIndex = 7;
		}	*/
	}
	
	//check record timelaps
	var resolution = document.getElementById("select_timelaps_resolution");
	var framerate = document.getElementById("select_timelaps_framerate");
	if  (resolution.value == "1920x1080" || resolution.value == "2048*1536" &&
		framerate.value == 30) {
		var quality = document.getElementById("select_timelaps_quality");
		if (g_current_nvr_model.nvr_name == "DR-2208P" ||
			g_current_nvr_model.nvr_name == "DR-2216P") { 
			if (1 < quality.selectedIndex)  quality.selectedIndex = 1;
		}
	}
	
	var resolution = document.getElementById("select_event_resolution");
	var framerate = document.getElementById("select_event_framerate");
	if  (resolution.value == "1920x1080" || resolution.value == "2048*1536" &&
		framerate.value == 30) {
		var quality = document.getElementById("select_event_quality");
		if (g_current_nvr_model.nvr_name == "DR-2208P" ||
			g_current_nvr_model.nvr_name == "DR-2216P") { 
			if (1 < quality.selectedIndex)  quality.selectedIndex = 1;
		}
	}
	// //check live2
	// resolution = document.getElementById("select_live2_resolution");
	// framerate = document.getElementById("select_live2_framerate");
	// if  (resolution.value == "640x360" &&
		// framerate.value == 30 &&
		// (g_current_nvr_model.nvr_name == "DR-6232(P/PS)")) {

	// }
}

function hideNonAnalogStreams(hide) 
{
	// var controls = document.getElementsByClassName("not_need");
	// var layer = document.getElementById("live1_row");
	
	// for (x in controls) {
		// controls[x].hidden = hide;
	// }
	// if (hide) {
		// layer.style.height = 95;
		// layer.style.verticalAlign = "top";
	// }
	// else {
		// layer.style.height = 28;
		// layer.style.verticalAlign = "middle";
	// }
	
	var control = document.getElementById("live_remote_setting_layer");
	var parent = document.getElementById("layer_camera_detail_setting");
	var main_div = document.getElementById("layer_setting");
	
	if (hide) {
		control.style.display = "none";
		parent.style.height = 395 - 150;
	}
	else {
		control.style.display = "block";
		parent.style.height = 395; 	
	}
}