var codec_list;	// use save new codecs
var codec;		// use make new codec
var device;		// use make new camera device

////////////// class Codec
// _name;
// _codecFactor;
// _resolution;
// _framelate;
// _quality;
// _resolutionFactor;
// _resolutionBias;
// _qualityIncreseRate;
//////////////////////////////////

////////////// class CameraDevice
// _model;
// _name;
// _maxSingleBitrate;
// _maxTotalBitrate;
// _maxStreamCount;
// _audioSupport;
// _codecs;
//////////////////////////////////

// Bitrate Unit - byte
// 1M == 1048576 byte


// global camera bitrate calculate function
var RES_352_240 = 0;
var RES_640_360 = 1;
var RES_704_480 = 2;
var RES_1280_720 = 3;
var RES_1920_1080 = 4;
var RES_3840_2160 = 5;
var RES_704_240 = 6;
var RES_320_240 = 7;
var RES_640_480 = 8;
var RES_2304_1296 = 9;
var RES_1024_1024 = 10;
var RES_2048_2048 = 11;
var RES_2048_1024 = 12;
var RES_2048_512 = 13;
var RES_1280_1024 = 14;
var RES_640_512 = 15;
var RES_720_480 = 16;
var RES_2048_1536 = 17;
var RES_1600_1200 = 18;
var RES_1400_1050 = 19;
var RES_1280_960 = 20;
var RES_1024_768 = 21;
var RES_800_600 = 22;
var RES_480_360 = 23;
var RES_400_300 = 24;
var RES_240_180 = 25;
var RES_2592_1944 = 26;
var RES_512_512 = 27;
var RES_1024_512 = 28;
var RES_960_480 = 29;
var RES_1536_1536 = 30;
var RES_2560_2048 = 31;
var RES_360_240 = 32;

function findResolution (codec, resIndex) {
    var resolution = codec.supprot_resolution_list[resIndex];
    
    switch (resolution) {
        case "352x240":        return RES_352_240;
        case "640x360":        return RES_640_360;
        case "704x480":        return RES_704_480;
        case "1280x720":        return RES_1280_720;
        case "1920x1080":      return RES_1920_1080;
        case "3840x2160":      return RES_3840_2160;
        case "704x240":         return RES_704_240;
        case "320x240":         return RES_320_240;
        case "640x480":         return RES_640_480;
        case "2304x1296":      return RES_2304_1296;
        case "1024x1024":      return RES_1024_1024;
        case "2048x2048":      return RES_2048_2048;
        case "2048x1024":      return RES_2048_1024;
        case "2048x512":        return RES_2048_512;
        case "1280x1024":      return RES_1280_1024;
        case "640x512":         return RES_640_512;
        case "720x480":         return RES_720_480;
        case "2048x1536":      return RES_2048_1536;
        case "1600x1200":      return RES_1600_1200;
        case "1400x1050":      return RES_1400_1050;
        case "1280x960":        return RES_1280_960;
        case "1024x768":        return RES_1024_768;
        case "800x600":         return RES_800_600;
        case "480x360":         return RES_480_360;
        case "400x300":         return RES_400_300;
        case "240x180":         return RES_240_180;
        case "2592x1944":      return RES_2592_1944;
		case "512x512":		return RES_512_512;
		case "1024x512":		return RES_1024_512;
		case "960x480":		return RES_960_480;
		case "1536x1536":		return RES_1536_1536;
		case "2560x2048":		return RES_2560_2048;
		case "360x240":		return RES_360_240;
    }
}

function encorder_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
    var resIndex = findResolution(this.codec_list[0], resolution);
    switch (resIndex) {
        case RES_360_240: resIdx = 0; break;
        case RES_640_360: resIdx = 1; break;
        case RES_720_480: resIdx = 2; break;
        case RES_960_480: resIdx = 3; break;
        default			: resIdx = -1; break;
    }
	if(resIdx == -1)
		return -1;
	var cbr = g_current_camera_model.codec_list[0].constant_bitrate_base * g_current_camera_model.codec_list[0].resolution_factor_list[resIdx] * g_current_camera_model.codec_list[0].quality_factor_list[resIdx][quality] * 8;
	var framerate_scale = Math.round(Math.sqrt(ips) * 10, 0);
	var framerate_scale_30 = Math.round(Math.sqrt(max_ips) * 10, 1);
	var bitrateFactor = (framerate_scale + g_current_camera_model.codec_list[0].resolution_bias_list[resIdx]) / (framerate_scale_30 + g_current_camera_model.codec_list[0].resolution_bias_list[resIdx]);
	
	if(resIdx == 1 && g_current_nvr_model.model_group == 11)
		bitrateFactor = bitrateFactor / 2;
    return cbr * bitrateFactor * max_ips;
}



function imx122_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
console.log(resolution + " " + quality + " " + ips + " " + max_ips + " " + codec);
	var imx122Bitrate = [ // IMX122, IMX222 
		[ 1* 256,  2* 256,  3* 256,   4* 256 ],    // 352x240
		[ 1*1024,  2*1024,  3*1024,   4*1024 ],    // 704x480
		[ 2*1024,  4*1024,  6*1024,   8*1024 ],    // 1280x720
		[ 4*1024,  6*1024,  8*1024,   10*1024*1.024],    // 1920x1080   IMX122 use 
		[ 1* 256,  2* 256,  3* 256,   4* 256 ],    // 320x240        
		[ 1*1024,  2*1024,  3*1024,   4*1024 ],    // 640x480
		[ 768,       1536,    2304,     3072 ]     // 640x360
	];

	var fps_scale = [               // 10 * sqrt(fps)
		0,
		10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
		33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
		46, 47, 48, 49, 50, 51, 52, 53, 54, 55 ];

	var res_bias = [
		10, // 352x240
		 8, // 704x480
		 2, // 1280x720
		 0, // 1920x1080
		10, // 320x240
		 8, // 640x480
		 8, // 640x360 need to be ajusted!!!!!!!!!!
	];

    var resIndex = findResolution(this.codec_list[0], resolution);
    
    switch (resIndex) {
        case RES_352_240: resIdx = 0; break;
        case RES_640_360: resIdx = 6; break;
        case RES_704_480: resIdx = 1; break;
        case RES_1280_720: resIdx = 2; break;
        case RES_1920_1080: resIdx = 3; break;
    }
	
//	switch (quality) {
//		case QUALITY_TYPE.QUALITY_LOW: 		qulIdx = 0; break;
//		case QUALITY_TYPE.QUALITY_BASIC: 		qulIdx = 0; break;
//		case QUALITY_TYPE.QUALITY_STANDARD: 	qulIdx = 1; break;
//		case QUALITY_TYPE.QUALITY_HIGH: 			qulIdx = 2; break;
//		case QUALITY_TYPE.QUALITY_VERY_HIGH: 	qulIdx = 3; break;
//	}
	
    return Math.round(imx122Bitrate[resIdx][quality] * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]));
}
function opal_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
console.log(resolution + " " + quality + " " + ips + " " + max_ips + " " + codec);
	var ar0330Bitrate = [ // ar0330
		[ 1* 256,  2* 256 ,  3* 256,   4* 256 ],            // 352x240
		[ 1*1024,  2*1024 ,  3*1024,   4*1024 ],            // 704x480
		[ 2*1024,  4*1024 ,  6*1024,   8*1024 ],            // 1280x720
		[ 4*1024,  6*1024 ,  8*1024,  10*1024*1.024 ],      // 1920x1080   ar0330 use
		[ 1* 256,  2* 256 ,  3* 256,   4* 256 ],            // 320x240
		[ 1*1024,  2*1024 ,  3*1024,   4*1024 ],            // 640x480
		[ 768   ,  1536   ,    2304,     3072 ],            // 640x360
		[ 5888  ,    8704 ,   11520,    14336 ],            // 2304_1296
		[ 5*1024,  10*1024, 12*1024,  14*1024*1.024 ],      // 2048_1536
		[ 4*1024,  8*1024 , 10*1024,    11500*1.024 ],      // 1600_1200
		[ 2*1024,   3*1024,  5*1024,   6*1024 ],            // 1024_768
	];

	var fps_scale = [               // 10 * sqrt(fps)
		0,
		10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
		33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
		46, 47, 48, 49, 50, 51, 52, 53, 54, 55 ];

	var res_bias = [
		10,     // 352x240
		8,     // 704x480
		2,     // 1280x720
		0,     // 1920x1080
		10,     // 320x240
		8,     // 640x480
		8, // 640x360 need to be ajusted!!!!!!!!!!
		0, // 2304_1296,
		0, // 2048_1536,
		1, // 1600_1200,
		3, // 1024_768,
	];

    var resIndex = findResolution(this.codec_list[0], resolution);
    
    switch (resIndex) {
        case RES_352_240: resIdx = 0; break;
        case RES_640_360: resIdx = 6; break;
        case RES_704_480: resIdx = 1; break;
        case RES_1280_720: resIdx = 2; break;
        case RES_1920_1080: resIdx = 3; break;
		case RES_320_240: resIdx = 4; break;
		case RES_640_480: resIdx = 5; break;
	    case RES_2304_1296: resIdx = 7; break;
        case RES_2048_1536: resIdx = 8; break;
        case RES_1600_1200: resIdx = 9; break;
        case RES_1024_768: resIdx = 10; break;
    }
	
//	switch (quality) {
//		case QUALITY_TYPE.QUALITY_LOW: 		qulIdx = 0; break;
//		case QUALITY_TYPE.QUALITY_BASIC: 		qulIdx = 0; break;
//		case QUALITY_TYPE.QUALITY_STANDARD: 	qulIdx = 1; break;
//		case QUALITY_TYPE.QUALITY_HIGH: 			qulIdx = 2; break;
//		case QUALITY_TYPE.QUALITY_VERY_HIGH: 	qulIdx = 3; break;
//	}
	
    return Math.round(ar0330Bitrate[resIdx][quality] * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]));
}

function pearlIMX_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
console.log(resolution + " " + quality + " " + ips + " " + max_ips + " " + codec + " " + directIP);
	var IMXBitrate = [ // IMX SENSOR
		[ 1* 256, 2* 256,  3* 256,  4* 256 ],   // 352x240
		[ 1*1024, 2*1024,  3*1024,  4*1024 ],   // 704x480
		[ 2*1024, 4*1024,  6*1024,  8*1024 ],   // 1280x720
		[ 4*1024, 6*1024, 8*1024,  10*1024 ],   // 1920x1080
		[    768,  1536,     2304,    3072 ],   // 640x360
	];

    var fps_scale = [             // 10 * sqrt(fps)
        0,
        10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
        33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
        46, 47, 48, 49, 50, 51, 52, 53, 54, 55];

	 var res_bias = [
		10,	// 352x240
		 8,	// 704x480
		 2,	// 1280x720
		 0,	// 1920x1080
		 8 // 640x360
	];

    var resIndex = findResolution(this.codec_list[0], resolution);
    
    switch (resIndex) {
        case RES_352_240: resIdx = 0; break;
        case RES_640_360: resIdx = 4; break;
        case RES_704_480: resIdx = 1; break;
        case RES_1280_720: resIdx = 2; break;
        case RES_1920_1080: resIdx = 3; break;
    }
	
	if (directIP) {
        if (resIndex == RES_1920_1080) {
            IMXBitrate[resIdx] = [4096, 6144, 8192, 10240];
		}
	}
    
    return Math.round(IMXBitrate[resIdx][quality] * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]));
}



function pearl_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
console.log(resolution + " " + quality + " " + ips + " " + max_ips + " " + codec + " " + directIP);
	var OVBitrate = [ // OV SENSOR
		[ 1* 256, 2* 256,  3* 256,  4* 256 ],   // 352x240
		[ 1*1024, 2*1024,  3*1024,  4*1024 ],   // 704x480
		[ 2*1024, 4*1024,  6*1024,  8*1024 ],   // 1280x720
		[ 4*1024, 8*1024, 10*1024,  11500*1.024 ],   // 1920x1080
		[    768,  1536,     2304,    3072 ],   // 640x360
	];

    var fps_scale = [             // 10 * sqrt(fps)
        0,
        10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
        33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
        46, 47, 48, 49, 50, 51, 52, 53, 54, 55];

	 var res_bias = [
		10,	// 352x240
		 8,	// 704x480
		 2,	// 1280x720
		 0,	// 1920x1080
		 8 // 640x360
	];

    var resIndex = findResolution(this.codec_list[0], resolution);
    
    switch (resIndex) {
        case RES_352_240: resIdx = 0; break;
        case RES_640_360: resIdx = 4; break;
        case RES_704_480: resIdx = 1; break;
        case RES_1280_720: resIdx = 2; break;
        case RES_1920_1080: resIdx = 3; break;
    }
	
	if (directIP) {
        if (resIndex == RES_1920_1080) {
            OVBitrate[resIdx] = [4096, 6144, 8192, 10240];
		}
	}
    
    return Math.round(OVBitrate[resIdx][quality] * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]));
}

function pearl_imx_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
console.log(resolution + " " + quality + " " + ips + " " + max_ips + " " + codec + " " + directIP);
    var H264_BITRATE =
       [[   256,    512,    768,   1024 ], //   352 x  240, 0.08M
        [  1024,   2048,   3072,   4096 ], //   704 x  480, 0.32M
        [  2048,   4096,   6144,   8192 ], //  1280 x  720, 0.88M
        [  4096,   6144,   8192,  10240 ], //  1920 x 1080, 1.98M
        [   768,   1536,   2304,   3072 ]];//   640 x  360, 0.22M

    var fps_scale = [             // 10 * sqrt(fps)
        0,
        10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
        33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
        46, 47, 48, 49, 50, 51, 52, 53, 54, 55];

    var res_bias = [
            10, // 352x240
             8, // 704x480
             2, // 1280x720
             0, // 1920x1080
             8, // 640x360
             ];

    var resIndex = findResolution(this.codec_list[0], resolution);
    
    switch (resIndex) {
        case RES_352_240: resIdx = 0; break;
        case RES_640_360: resIdx = 4; break;
        case RES_704_480: resIdx = 1; break;
        case RES_1280_720: resIdx = 2; break;
        case RES_1920_1080: resIdx = 3; break;
    }
    
    return H264_BITRATE[resIdx][quality] * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]);
}

function topaz_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
console.log(resolution + " " + quality + " " + ips + " " + max_ips + " " + codec + " " + directIP);
    var H264_BITRATE =[	// OV SENSOR
		[ 1* 256,    2* 256,    3* 256,    4* 256 ],    // 352x240
		[ 1*1024,    2*1024,    3*1024,    4*1024 ],    // 704x480
		[ 2*1024,    4*1024,    6*1024,    8*1024 ],    // 1280x720
		[ 4*1024,    8*1024,   10*1024,     11500*1.024 ],    // 1920x1080
		[ 1* 256,    2* 256,    3* 256,    4*256  ],    // 320x240        
		[ 1*1024,    2*1024,    3*1024,    4*1024 ],    // 640x480
		[ 768	,      1536,      2304,     3072  ],    // 640x360
		];

	var fps_scale = [               // 10 * sqrt(fps)
		0,
		10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
		33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
		46, 47, 48, 49, 50, 51, 52, 53, 54, 55 ];

	var res_bias = [
		10, // 352x240
		 8, // 704x480
		 2, // 1280x720
		 0, // 1920x1080
		10, // 320x240
		 8, // 640x480
		 8, // 640x360 need to be ajusted!!!!!!!!!!
	];

    var resIndex = findResolution(this.codec_list[0], resolution);
    
    switch (resIndex) {
        case RES_352_240: resIdx = 0; break;
        case RES_640_360: resIdx = 6; break;
        case RES_704_480: resIdx = 1; break;
        case RES_1280_720: resIdx = 2; break;
        case RES_1920_1080: resIdx = 3; break;
		case RES_320_240: resIdx = 4; break;
		case RES_640_480: resIdx = 5; break;
    }
	
//	switch (quality) {
//		case QUALITY_TYPE.QUALITY_LOW: 		qulIdx = 0; break;
//		case QUALITY_TYPE.QUALITY_BASIC: 		qulIdx = 0; break;
//		case QUALITY_TYPE.QUALITY_STANDARD: 	qulIdx = 1; break;
//		case QUALITY_TYPE.QUALITY_HIGH: 			qulIdx = 2; break;
//		case QUALITY_TYPE.QUALITY_VERY_HIGH: 	qulIdx = 3; break;
//	}
	
	if (directIP) {
        if (resIndex == RES_1920_1080) {
            H264_BITRATE[resIdx] = [4096, 6144, 8192, 10240];
		}
	}
    
    return H264_BITRATE[resIdx][quality] * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]);
}

function topaz_imx_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
console.log(resolution + " " + quality + " " + ips + " " + max_ips + " " + codec + " " + directIP);
	var imx122Bitrate = [ // IMX122, IMX222 
		[ 1* 256,  2* 256,  3* 256,   4* 256 ],    // 352x240
		[ 1*1024,  2*1024,  3*1024,   4*1024 ],    // 704x480
		[ 2*1024,  4*1024,  6*1024,   8*1024 ],    // 1280x720
		[ 4*1024,  6*1024,  8*1024,   10*1024*1.024],    // 1920x1080   IMX122 use 
		[ 1* 256,  2* 256,  3* 256,   4* 256 ],    // 320x240        
		[ 1*1024,  2*1024,  3*1024,   4*1024 ],    // 640x480
		[ 768,       1536,    2304,     3072 ]     // 640x360
	];

    var fps_scale = [             // 10 * sqrt(fps)
        0,
        10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
        33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
        46, 47, 48, 49, 50, 51, 52, 53, 54, 55];

    var res_bias = [
            10, // 352x240
             8, // 704x480
             2, // 1280x720
             0, // 1920x1080
            10, // 320x240
             8, // 640x480
             8, // 640x360
             ];

    var resIndex = findResolution(this.codec_list[0], resolution);
    
    switch (resIndex) {
        case RES_352_240: resIdx = 0; break;
        case RES_640_360: resIdx = 6; break;
        case RES_704_480: resIdx = 1; break;
        case RES_1280_720: resIdx = 2; break;
        case RES_1920_1080: resIdx = 3; break;
		case RES_320_240: resIdx = 4; break;
		case RES_640_480: resIdx = 5; break;
    }
    
    return Math.round(imx122Bitrate[resIdx][quality] * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]));
}

function zircon_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
	console.log(resolution + " " + quality + " " + ips + " " + max_ips + " " + codec + " " + directIP);
	var H264_BITRATE =
	   [[   256,    512,    768,   1024 ], // G2_IMAGE_RESOLUTION_CIF,    352 x  240, 0.08M
		[   512,   1024,   1536,   2048 ], // G2_IMAGE_RESOLUTION_2CIF,   704 x  240, 0.16M
		[  1024,   2048,   3072,   4096 ], // G2_IMAGE_RESOLUTION_4CIF,   704 x  480, 0.32M
		[  2048,   4096,   6144,   8192 ], // G2_IMAGE_RESOLUTION_720P,  1280 x  720, 0.88M
		[  4096,   8192,  10240,  12288 ], // G2_IMAGE_RESOLUTION_1080P, 1920 x 1080, 1.98M
		[   768,   1536,   2304,   3072 ], // G2_IMAGE_RESOLUTION_NHD,    640 x  360, 0.22M
		[   250,    502,   752,    1004 ], // G2_IMAGE_RESOLUTION_QVGA,   320 x  240, 0.07M
		[   896,   1792,   2688,   3584 ], // G2_IMAGE_RESOLUTION_VGA,    640 x  480, 0.29M
		[  5530,   9216,  11520,  13824 ], // G2_IMAGE_RESOLUTION_3M,    2304 x 1296, 2.85M
		[     0,      0,      0,      0 ], // Custom

		[  2176,   4352,   6528,   8704 ], // 1024 x 1024, 1.00M
		[  9216,  12288,  15360,  18432 ], // 3840 x 2160, 7.91M
		[  7680,  10240,  12800,  15360 ], // 2048 x 2048, 4.00M
		[   832,   1664,   2496,   3328 ], //  512 x  512, 0.25M
		[  1152,   2304,   3456,   4608 ], //  720 x  576, 0.40M
		[  8192,  10922,  13654,  16384 ], // 2560 x 2048, 5.00M
		[  4096,   8192,  10240,  12288 ], // 2048 x 1024, 2.00M
		[  2176,   4352,   6528,   8704 ], // 2048 x  512, 1.00M
		[  4266,   8534,  10668,  12800 ], // 1536 x 1536, 2.25M
		[  1408,   2816,   4224,   5632 ], // 1024 x  512, 0.50M
		[  2820,   5642,   7782,   9728 ], // 1280 x 1024, 1.25M
		[   972,   1944,   2918,   3890 ], //  640 x  512, 0.31M
		[  1152,   2304,   3456,   4608 ], //  720 x  480, 0.33M

		[  5324,   8874,  11094,  13312 ], // 2048 x 1536, 3.00M
		[  3924,   7850,   9814,  11776 ], // 1600 x 1200, 1.83M
		[  2970,   5938,   8192,  10240 ], // 1400 x 1050, 1.40M
		[  2672,   5344,   7372,   9216 ], // 1280 x  960, 1.17M
		[  1792,   3584,   5376,   7168 ], // 1024 x  768, 0.75M
		[  1280,   2560,   3840,   5120 ], //  800 x  600, 0.46M
		[   512,   1024,   1536,   2048 ], //  480 x  360, 0.16M
		[   384,    768,   1152,   1536 ], //  400 x  300, 0.11M
		[   230,    460,    692,    922 ], //  240 x  180, 0.04M
		[  8088,  10786,  13482,  16178 ],  // 2592 x 1944, 4.81M
		
		[   236,    470,    706,    942 ], //  320 x  180, 0.05M
		[ 10240,  13654,  17068,  20480 ], // 4000 x 3000, 11.44M

		[  9472,  12630,  15788,  18944 ], // 3000 x 3000, 8.58M
		[  8104,  10806,  13508,  16208 ], // 2250 x 2250, 4.83M
		[  7832,  10444,  13056,  15666 ], // 3000 x 1500, 4.29M
		[  4146,   8294,  10366,  12440 ], // 1500 x 1500, 2.15M
		[  1418,   2836,   4254,   5672 ]]; //  750 x  750, 0.54M
		
	var H265_BITRATE = 
	   [[   128,    256,    384,    512 ], // G2_IMAGE_RESOLUTION_CIF,    352 x  240, 0.08M
		[   256,    512,    768,   1024 ], // G2_IMAGE_RESOLUTION_2CIF,   704 x  240, 0.16M
		[   640,   1024,   1536,   2048 ], // G2_IMAGE_RESOLUTION_4CIF,   704 x  480, 0.32M
		[  1024,   2048,   3072,   4096 ], // G2_IMAGE_RESOLUTION_720P,  1280 x  720, 0.88M
		[  2048,   4096,   5120,   6144 ], // G2_IMAGE_RESOLUTION_1080P, 1920 x 1080, 1.98M
		[   384,    768,   1152,   1536 ], // G2_IMAGE_RESOLUTION_NHD,    640 x  360, 0.22M
		[   125,    251,    376,    502 ], // G2_IMAGE_RESOLUTION_QVGA,   320 x  240, 0.07M
		[   448,    896,   1344,   1792 ], // G2_IMAGE_RESOLUTION_VGA,    640 x  480, 0.29M
		[  2765,   4608,   5760,   6912 ], // G2_IMAGE_RESOLUTION_3M,    2304 x 1296, 2.85M
		[     0,      0,      0,      0 ], // Custom

		[  1088,   2176,   3264,   4352 ], // 1024 x 1024, 1.00M
		[  4608,   6144,   7680,   9216 ], // 3840 x 2160, 7.91M
		[  3840,   5120,   6400,   7680 ], // 2048 x 2048, 4.00M
		[   416,    832,   1248,   1664 ], //  512 x  512, 0.25M
		[   576,   1152,   1728,   2304 ], //  720 x  576, 0.40M
		[  4096,   5461,   6827,   8192 ], // 2560 x 2048, 5.00M
		[  2048,   4096,   5120,   6144 ], // 2048 x 1024, 2.00M
		[  1088,   2176,   3264,   4352 ], // 2048 x  512, 1.00M
		[  2133,   4267,   5334,   6400 ], // 1536 x 1536, 2.25M
		[   704,   1408,   2112,   2816 ], // 1024 x  512, 0.50M
		[  1410,   2821,   3891,   4864 ], // 1280 x 1024, 1.25M
		[   486,    972,   1459,   1945 ], //  640 x  512, 0.31M
		[   576,   1152,   1728,   2304 ], //  720 x  480, 0.33M

		[  2662,   4437,   5547,   6656 ], // 2048 x 1536, 3.00M
		[  1962,   3925,   4907,   5888 ], // 1600 x 1200, 1.83M
		[  1485,   2969,   4096,   5120 ], // 1400 x 1050, 1.40M
		[  1336,   2672,   3686,   4608 ], // 1280 x  960, 1.17M
		[   896,   1792,   2688,   3584 ], // 1024 x  768, 0.75M
		[   640,   1280,   1920,   2560 ], //  800 x  600, 0.46M
		[   256,    512,    768,   1024 ], //  480 x  360, 0.16M
		[   192,    384,    576,    768 ], //  400 x  300, 0.11M
		[   115,    230,    346,    461 ], //  240 x  180, 0.04M
		[  4044,   5393,    6741,  8089 ], // 2592 x 1944, 4.81M
		
		[   118,    235,    353,    471 ], //  320 x  180, 0.05M
		[  5120,   6827,   8534,  10240 ], // 4000 x 3000, 11.44M

		[  4736,   6315,   7894,   9472 ], // 3000 x 3000, 8.58M
		[  4052,   5403,   6754,   8104 ], // 2250 x 2250, 4.83M
		[  3916,   5222,   6528,   7833 ], // 3000 x 1500, 4.29M
		[  2073,   4147,   5183,   6220 ], // 1500 x 1500, 2.15M
		[   709,   1418,   2127,   2836 ]]; //  750 x  750, 0.54M

	var fps_scale = [             // 10 * sqrt(fps)
			0,
			10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
			33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
			46, 47, 48, 49, 50, 51, 52, 53, 54, 55,
			55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
			55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
			55, 55, 55, 55, 55, 55, 55, 55, 55, 55];

	var res_bias = [
			10, // 352x240
			 9, // 704x240
			 8, // 704x480
			 2, // 1280x720
			 0, // 1920x1080
			 8, // 640x360
			10, // 320x240
			 8, // 640x480
			 0, // 3M
			 0, // CUSTOM
			 2, // 1024x1024
			 0, // 3840x2160
			 0, // 2048x2048
			 8, // 512x512
			 7, // 720x576
			 0, // 2560x2048
			 0, // 2048x1024
			 2, // 2048x512
			 0, // 1536x1536
			 2, // 1024x512
			 1, // 1280x1024
			 8, // 640x512
			 8, // 720x480
			 0, // 2048x1536
			 0, // 1600x1200
			 1, // 1400x1050
			 2, // 1280x960
			 4, // 1024x768
			 6, // 800x600
			 9, // 480x360
			 9, // 400x300
			 10,// 240x180
			 0, // 2592 x 1944
			 10,// 320x180
			 0, // 4000x3000
			 0, // 3000x3000
			 0, // 2250x2250
			 0, // 3000x1500
			 1, // 1500x1500
			 6, // 750x750
			 ];

        var bitrate = 0;
        var maxBitrate = 0;
        var resIndex = findResolution(this.codec_list[0], resolution);
        
        switch (resIndex) {
            case RES_352_240: resIdx = 0; break;
            case RES_640_360: resIdx = 5; break;
            case RES_704_480: resIdx = 2; break;
            case RES_1280_720: resIdx = 3; break;
            case RES_1920_1080: resIdx = 4; break;
			case RES_3840_2160:	resIdx = 11; break;
			case RES_704_240: resIdx = 1; break;
			case RES_320_240: resIdx = 6; break;
			case RES_640_480: resIdx = 7; break;
			case RES_2304_1296: resIdx = 8; break;
			case RES_1024_1024: resIdx = 10; break;
			case RES_2048_2048: resIdx = 12; break;
			case RES_2048_1024: resIdx = 16; break;
			case RES_2048_512: resIdx = 17; break;
			case RES_1280_1024: resIdx = 20; break;
			case RES_640_512: resIdx = 21; break;
			case RES_720_480: resIdx = 22; break;
			case RES_2048_1536: resIdx = 23; break;
			case RES_1600_1200: resIdx = 24; break;
			case RES_1400_1050: resIdx = 25; break;
			case RES_1280_960: resIdx = 26; break;
			case RES_1024_768: resIdx = 27; break;
			case RES_800_600: resIdx = 28; break;
			case RES_480_360: resIdx = 29; break;
			case RES_400_300: resIdx = 30; break;
			case RES_240_180: resIdx = 31; break;
			case RES_2592_1944: resIdx = 32; break;
        }
        
        if (directIP) {
           if (resIndex == RES_1920_1080) {
               if (codec == 0) {
                   H264_BITRATE[resIdx] = [4096, 6144, 8192, 10240];
               }
               else if (codec == 1) {
                   H265_BITRATE[resIdx] = [2048, 3072, 4096, 5120];
               }
           }
		   else if (resIndex == RES_2048_1536) {
               if (codec == 0) {
                   H264_BITRATE[resIdx] = [5120, 6826, 8534, 10240];
               }
		   }
		   else if (resIndex == RES_1600_1200) {
               if (codec == 0) {
                   H264_BITRATE[resIdx] = [3850, 6418, 8022, 9626];
               }
		   }
        }
		
        switch (codec) {
            case 0: maxBitrate = H264_BITRATE[resIdx][quality]; break;
            case 1: maxBitrate = H265_BITRATE[resIdx][quality]; break;
        }
		
        if (30 == ips) {
            bitrate = maxBitrate;
        }
        else {
            if (60 == ips)  maxBitrate = (maxBitrate * 3) >> 1;
            bitrate = maxBitrate * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]);
        }
        
        return bitrate;
}

function s2_platform_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{   
	var H264_BITRATE = [
		// GARNET, SARD
		[   256,    512,    768,   1024 ], // 0 -  352 x  240,
		[   768,   1536,   2304,   3072 ], // 1 -  640 x  360,
		[  1024,   2048,   3072,   4096 ], // 2 -  704 x  480, 
		[  2048,   4096,   6144,   8192 ], // 3 - 1280 x  720, 
		[  4096,   8192,  10240,  11776 ], // 4 - 1920 x 1080, 
		[ 10240,  12288,  15360,  18474 ], // 5 - 3840 x 2160,

		// ONYX
		[  1024,   2048,    3072,   4096 ], // 6 -  512 x  512,
		[  1024,   2048,   3072,   4096 ], // 7 -  640 x  512, 
		[  1024,   2048,   3072,   4096 ], // 8 - 1024 x  512, 
		[  2048,   4096,   6144,   8192 ], // 9 - 1024 x 1024, 
		[  3072,   5120,  8192,  10240 ], //10 - 1280 x 1024, 
		[  4096,  8192,  10240,  11776 ], //11 - 1536 x 1536,
		[  4096,  8192,  10240,  11776 ], //12 - 2048 x 1024,
		[ 10240,  12288,  14336,  16384 ], //13 - 2048 x 2048,
		[ 10240,  12288,  14336,  16384 ]];//14 - 2560 x 2048,

	var fps_scale = [             // 10 * sqrt(fps)
		0,
		10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
		33, 35, 36, 37, 39, 40, 41, 42, 14, 45,
		46, 47, 48, 49, 50, 51, 52, 53, 54, 55];

	var res_bias = [
		// GARNET, SARD
		10, //  0 -  352 x  240
		 8, //  1 -  640 x  480
		 8, //  2 -  704 x  480
		 2, //  3 - 1280 x  720
		 0, //  4 - 1920 x 1080
		 0, //  5 - 3840 x 2160
		// ONYX
		 8, //  6 -  512 x  512
		 8, //  7 -  640 x  512
		 2, //  8 - 1024 x  512
		 2, //  9 - 1024 x 1024
		 1, // 10 - 1280 x 1024
		 0, // 11 - 1536 x 1536
		 0, // 12 - 2048 x 1024
		 0, // 13 - 2048 x 2048
		 0, // 14 - 2560 x 2048
	 ];
	 
	 var resIndex = findResolution(this.codec_list[0], resolution);
	 
	 switch (resIndex) {
		// GARNET, SARD
		case RES_352_240:   resIdx =  0; break;
		case RES_640_360:   resIdx =  1; break;
		case RES_704_480:   resIdx =  2; break;
		case RES_1280_720:  resIdx =  3; break;
		case RES_1920_1080: resIdx =  4; break;
		case RES_3840_2160: resIdx =  5; break;
		// ONYX
		case RES_512_512:   resIdx =  6; break;
		case RES_640_512:   resIdx =  7; break;
		case RES_1024_512:  resIdx =  8; break;
		case RES_1024_1024: resIdx =  9; break;
		case RES_1280_1024: resIdx = 10; break;
		case RES_1536_1536: resIdx = 11; break;
		case RES_2048_1024: resIdx = 12; break;
		case RES_2048_2048: resIdx = 13; break;
		case RES_2560_2048: resIdx = 14; break;
	}
	
    var calcBitrate = 0;
	if (directIP) {
        if (resIndex == RES_1920_1080) {
            if (codec == 0) {
                H264_BITRATE[resIdx] = [4096, 6144, 8192, 10240];
            }
            else if (codec == 1) {
                H265_BITRATE[resIdx] = [2048, 3072, 4096, 5120];
            }
        }
	}
	maxBitrateVal = H264_BITRATE[resIdx][quality];	
	
	if (ips == 60) {
		if(5 <= resIdx) { // all of resolution on ONYX and 4K not support 60 ips
			calcBitrate = -1
			return calcBitrate;
		}
		else	{
			calcBitrate = maxBitrateVal * 1.5;
		}
    }   
    else {
		calcBitrate = maxBitrateVal * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]);
    }
    return Math.round(calcBitrate);
}

/*********************************************************************
*	Camera Model DC-B10xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-B10xx Series",	// _model
//	"DC-B10xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	10,	// _model_group
//	topaz_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-B11xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-B11xx Series",	// _model
//	"DC-B11xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	11,	// _model_group
//	topaz_camera_bitrate
//);
//
///****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model NC-B320(DC-B12xx) Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-B320 Series",//	"DC-B12xx Series",	// _model
	"NC-B320 Series",//	"DC-B12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12,	// _model_group
	topaz_camera_bitrate
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-B13xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-B13xx Series",	// _model
//	"DC-B13xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	12,	// _model_group
//	opal_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720","1920x1080","2304x1296"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16,32],	// _resolutionFactor
//	[10,9,8,2,0,0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88],[1,1.5,2,2.5]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-D10xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-D10xx Series",	// _model
//	"DC-D10xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	10,	// _model_group
//	topaz_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model NC-ED310(DC-D11xx) Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-ED310 Series",//	"DC-D11xx Series",	// _model
	"NC-ED310 Series",//	"DC-D11xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	11,	// _model_group
	topaz_camera_bitrate
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model NC-D320(DC-D12xx) Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-D320 Series",//	"DC-D12xx Series",	// _model
	"NC-D320 Series",//	"DC-D12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12,	// _model_group
	topaz_camera_bitrate
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);


/*********************************************************************
*	Camera Model DC-D13xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-D13xx Series",	// _model
//	"DC-D13xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	13,	// _model_group
//	opal_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720","1920x1080","2304x1296"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16,32],	// _resolutionFactor
//	[10,9,8,2,0,0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.5,2,2.5],[1,1.5,2,2.5]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-D22xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-D22xx Series",	// _model
//	"DC-D22xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	12,	// _model_group
//	imx122_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2,0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-E11xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-E11xx Series",	// _model
//	"DC-E11xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	11,	// _model_group
//	pearl_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-E12xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-E12xx Series",	// _model
//	"DC-E12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	12,	// _model_group
//	pearl_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2,0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-F11xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-F11xx Series",	// _model
//	"DC-F11xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	11,	// _model_group
//	pearl_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-F12xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-F12xx Series",	// _model
//	"DC-F12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	12,	// _model_group
//	pearl_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2,0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-S11xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-S11xx Series",	// _model
//	"DC-S11xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	11,	// _model_group
//	pearlIMX_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model NC-S220(DC-S12xx) Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-S220 Series",//	"DC-S12xx Series",	// _model
	"NC-S220 Series",//	"DC-S12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12,	// _model_group
	pearlIMX_camera_bitrate
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-T12xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-T12xx Series",	// _model
//	"DC-T12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	12,	// _model_group
//	imx122_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2,0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-Z11xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-Z11xx Series",	// _model
//	"DC-Z11xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	11,	// _model_group
//	topaz_imx_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-Z12xx Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-Z12xx Series",	// _model
//	"DC-Z12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	12,	// _model_group
//	topaz_imx_camera_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1,2.7,4,8,16],	// _resolutionFactor
//	[10,9,8,2,0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);




/*********************************************************************
*	Camera Model  NC-FE550(DC-Y1513)
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-FE550-DP",	// _model
	"NC-FE550 Series",//	"DC-Y15xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	98,	// _model_group
	s2_platform_camera_bitrate
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
//	["512x512","640x512","1024x512","1024x1024","1280x1024","1536x1536","2048x1024","2048x2048","2560x2048"],// _resolution
	[          "640x512",                       "1280x1024",                                    "2560x2048"],// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[   4,       12,             40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[   8,       1.5,          0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
	[          [1,2,3,4],                    [1,1.66,2.66,3.33],                                          [1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);


/*********************************************************************
*	Camera Model  DC-B1803
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"NC-B580-DP",	// _model
//	"DC-B1803",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	98,	// _model_group
//    s2_platform_camera_bitrate
// );

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080", "3840x2160"], // _resolution
//	[1,2,3,4,5,10,15,30, 60],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  NC-A580-3MWH
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-A580-3MWH",	// _model
	"NC-A580-3MWH",//	"DC-T1833WHR",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	98,	// _model_group
    s2_platform_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080", "3840x2160"], // _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  DC-D3233X
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"NC-D620-3MXD",	// _model
//	"DC-D3233X",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	97,	// _model_group
//    zircon_camera_bitrate
// );

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
//	[1,2,3,4,5,10,15,30,60],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);

/****************************Codec H265****************************/
//codec = new Codec(
//	"H265",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
//	[1,2,3,4,5,10,15,30,60],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//
//g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  NC-D620-3MXI(DC-D3233RX)
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-D620-3MXI",	// _model
	"NC-D620-3MXI",//	"DC-D3233RX",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30,60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  NC-D620-3MXW(DC-D3233WRX)
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-D620-3MXW",	// _model
	"NC-D620-3MXW",//	"DC-D3233WRX",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

g_camera_device_list.push(device);


/*********************************************************************
*	Camera Model  DC-E3212WRX
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"NC-EA620-XWI",	// _model
//	"DC-E3212WRX",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	97,	// _model_group
//    zircon_camera_bitrate
// );

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);

/****************************Codec H265****************************/
//codec = new Codec(
//	"H265",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//
//g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  NC-A620-3MXH(DC-T3233HRX)
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-A620-3MXH",	// _model
	"NC-A620-3MXH",//	"DC-T3233HRX",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  DC-T3533HRX
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"NC-A650-3MXH",	// _model
//	"DC-T3533HRX",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	97,	// _model_group
//    zircon_camera_bitrate
// );

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x480", "1280x960", "2592x1944"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);

/****************************Codec H265****************************/
//codec = new Codec(
//	"H265",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x480", "1280x960", "2592x1944"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//
//g_camera_device_list.push(device);


// /*********************************************************************
// *	Camera Model  NC-G650-3MXP
// *********************************************************************/
// codec_list = new Array();
// device = new CameraDevice(
	// "NC-G650-3MXP",	// _model
	// "NC-G650-3MXP",	// _name
	// 104857600,	// _maxSingleBitrate
	// 104857600,	// _maxTotalBitrate
	// 1,	// _maxStreamCount
	// 0,	// _audioSupport
	// codec_list,	// _codecs
	// 97,	// _model_group
    // zircon_camera_bitrate
 // );

// /****************************Codec H264****************************/
// codec = new Codec(
	// "H264",	// _name
	// 1.066000,	// _codecFactor
    // ["320x240", "640x480", "1600x1200", "2592x1944"], // _resolution
	// [1,2,3,4,5,10,15,30],	// _framelate
	// ["Basic","Standard","High","Very High"],	// _quality
	// [4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	// [8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	// [[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
// );
// device.codec_list.push(codec);

// /****************************Codec H265****************************/
// codec = new Codec(
	// "H265",	// _name
	// 1.066000,	// _codecFactor
    // ["320x240", "640x480", "1280x960", "2592x1944"], // _resolution
	// [1,2,3,4,5,10,15,30],	// _framelate
	// ["Basic","Standard","High","Very High"],	// _quality
	// [4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	// [8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	// [[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
// );
// device.codec_list.push(codec);
// g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  DC-B3303X
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-B3303X",	// _model
//	"DC-B3303X",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	97,	// _model_group
//    zircon_camera_bitrate
// );

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//    ["320x240", "352x240", "480x360", "640x360", "704x480", "800x600", "1280x720", "1280x960", "1600x1200", "1920x1080", "2048x1536"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);

/****************************Codec H265****************************/
//codec = new Codec(
//	"H265",	// _name
//	1.066000,	// _codecFactor
//    ["320x240", "352x240", "480x360", "640x360", "704x480", "800x600", "1280x720", "1280x960", "1600x1200", "1920x1080", "2048x1536"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model  NC-EP620-XP(DC-D3212X)
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-EP620-XP",//	"DC-D3212X",	// _model
	"NC-EP620-XP",//	"DC-D3212X",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model  DC-D3212RX
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-D3212RX",	// _model
//	"DC-D3212RX",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	97,	// _model_group
//    zircon_camera_bitrate
// );

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);

/****************************Codec H265****************************/
//codec = new Codec(
//	"H265",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model  DC-T3243HRX
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DC-T3243HRX",	// _model
//	"DC-T3243HRX",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	97,	// _model_group
//    zircon_camera_bitrate
// );

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);

/****************************Codec H265****************************/
//codec = new Codec(
//	"H265",	// _name
//	1.066000,	// _codecFactor
//    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
//	[1,2,3,4,5,10,15,30, 60],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
//	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DE-110x Series
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"DE-110x Series",	// _model
//	"DE-110x Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	12,	// _model_group
//	encorder_bitrate
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	1.066000,	// _codecFactor
//	["360x240","640x360","720x480","960x480"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[1, 2.66, 4, 4],	// _resolutionFactor
//	[10,9,8,8,2],	// _resolutionBias
//	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


//Analog Cameras
//AnalogEE라EEfactorE E E보EE E~~~E EEE.
// factorE대EEEresolutionEEE는 Enum match E이EEEEEEE
//D1		:0
//720P	:1
//960H	:2
//1080P	:3

//E 는 EEEEE호E factorEEEEEEE리자
/*********************************************************************
*	D1 Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"D1 Camera",	// _model
	"D1 Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	99	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	17.06,	// _codecFactor
	["Standard", "High", "Very High"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[0],	// _resolutionFactor
	[0],	// _resolutionBias
	[0]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	960H Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"960H Camera",	// _model
	"960H Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	99	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	17.06,	// _codecFactor
	["Standard", "High", "Very High"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[2],	// _resolutionFactor
	[2],	// _resolutionBias
	[2]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	1MP Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"1MP Camera",	// _model
	"1MP Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	99	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	17.06,	// _codecFactor
	["Standard", "High", "Very High"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1],	// _resolutionFactor
	[1],	// _resolutionBias
	[1]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	2MP Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"2MP Camera",	// _model
	"2MP Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	99	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	17.06,	// _codecFactor
	["Standard", "High", "Very High"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[3],	// _resolutionFactor
	[3],	// _resolutionBias
	[3]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);


/*********************************************************************
*	TC-B12xx Series Camera
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"TC-B12xx Series",	// _model
//	"TC-B12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	99	// _model_group
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	17.06,	// _codecFactor
//	["Standard", "High", "Very High"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[3],	// _resolutionFactor
//	[3],	// _resolutionBias
//	[3]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


/*********************************************************************
*	TC-D12xx Series Camera
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"TC-D12xx Series",	// _model
//	"TC-D12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	99	// _model_group
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	17.06,	// _codecFactor
//	["Standard", "High", "Very High"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[3],	// _resolutionFactor
//	[3],	// _resolutionBias
//	[3]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


/*********************************************************************
*	TC-E12xx Series Camera
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"TC-E12xx Series",	// _model
//	"TC-E12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	99	// _model_group
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	17.06,	// _codecFactor
//	["Standard", "High", "Very High"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[3],	// _resolutionFactor
//	[3],	// _resolutionBias
//	[3]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


/*********************************************************************
*	TC-T12xx Series Camera
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"TC-T12xx Series",	// _model
//	"TC-T12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	99	// _model_group
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	17.06,	// _codecFactor
//	["Standard", "High", "Very High"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[3],	// _resolutionFactor
//	[3],	// _resolutionBias
//	[3]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


/*********************************************************************
*	Camera Model Custom Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"Custom Camera",	// _model
	"Custom Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	100	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["-","-","-"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["-","-","-","-"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8],	// _resolutionBias
	[[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

