﻿var codec_list;	// use save new codecs
var codec;		// use make new codec
var device;		// use make new camera device

////////////// class Codec
// _name;
// _codecFactor;
// _resolution;
// _framelate;
// _quality;
// _resolutionFactor;
// _resolutionBasi;
// _qualityIncreseRate;
//////////////////////////////////

////////////// class CameraDevice
// _model;
// _name;
// _maxSingleBitrate;
// _maxTotalBitrate;
// _maxStreamCount;
// _audioSupport;
// _codecs;
//////////////////////////////////

// Bitrate Unit - byte
// 1M == 1048576 byte


// global camera bitrate calculate function
var RES_352_240 = 0;
var RES_640_360 = 1;
var RES_704_480 = 2;
var RES_1280_720 = 3;
var RES_1920_1080 = 4;
var RES_3840_2160 = 5;
var RES_704_240 = 6;
var RES_320_240 = 7;
var RES_640_480 = 8;
var RES_2304_1296 = 9;
var RES_1024_1024 = 10;
var RES_2028_2048 = 11;
var RES_2028_1024 = 12;
var RES_2028_512 = 13;
var RES_1280_1024 = 14;
var RES_640_512 = 15;
var RES_720_480 = 16;
var RES_2048_1536 = 17;
var RES_1600_1200 = 18;
var RES_1400_1050 = 19;
var RES_1280_960 = 20;
var RES_1024_768 = 21;
var RES_800_600 = 22;
var RES_480_360 = 23;
var RES_400_300 = 24;
var RES_240_180 = 25;
var RES_1592_1944 = 26;


function findResolution (codec, resIndex) {
    var resolution = codec.supprot_resolution_list[resIndex];
    
    switch (resolution) {
        case "352x240":        return RES_352_240;
        case "640x360":        return RES_640_360;
        case "704x480":        return RES_704_480;
        case "1280x720":        return RES_1280_720;
        case "1920x1080":      return RES_1920_1080;
        case "3840x2160":      return RES_3840_2160;
        case "704x240":         return RES_704_240;
        case "320x240":         return RES_320_240;
        case "640x480":         return RES_640_480;
        case "2304x1296":      return RES_2304_1296;
        case "1024x1024":      return RES_1024_1024;
        case "2028x2048":      return RES_2028_2048;
        case "2028x1024":      return RES_2028_1024;
        case "2028x512":        return RES_2028_512;
        case "1280x1024":      return RES_1280_1024;
        case "640x512":         return RES_640_512;
        case "720x480":         return RES_720_480;
        case "2048x1536":      return RES_2048_1536;
        case "1600x1200":      return RES_1600_1200;
        case "1400x1050":      return RES_1400_1050;
        case "1280x960":        return RES_1280_960;
        case "1024x768":        return RES_1024_768;
        case "800x600":         return RES_800_600;
        case "480x360":         return RES_480_360;
        case "400x300":         return RES_400_300;
        case "240x180":         return RES_240_180;
        case "1592x1944":      return RES_1592_1944;
    }
}

function zircon_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
    var H264_BITRATE =
       [[   256,    512,    768,   1024 ], // G2_IMAGE_RESOLUTION_CIF,    352 x  240, 0.08M
        [   512,   1024,   1536,   2048 ], // G2_IMAGE_RESOLUTION_2CIF,   704 x  240, 0.16M
        [  1024,   2048,   3072,   4096 ], // G2_IMAGE_RESOLUTION_4CIF,   704 x  480, 0.32M
        [  2048,   4096,   6144,   8192 ], // G2_IMAGE_RESOLUTION_720P,  1280 x  720, 0.88M
        [  4096,   8192,  10240,  12288 ], // G2_IMAGE_RESOLUTION_1080P, 1920 x 1080, 1.98M
        [   768,   1536,   2304,   3072 ], // G2_IMAGE_RESOLUTION_NHD,    640 x  360, 0.22M
        [   250,    502,   752,    1004 ], // G2_IMAGE_RESOLUTION_QVGA,   320 x  240, 0.07M
        [   896,   1792,   2688,   3584 ], // G2_IMAGE_RESOLUTION_VGA,    640 x  480, 0.29M
        [  5530,   9216,  11520,  13824 ], // G2_IMAGE_RESOLUTION_3M,    2304 x 1296, 2.85M
        [     0,      0,      0,      0 ], // Custom

        [  2176,   4352,   6528,   8704 ], // 1024 x 1024, 1.00M
        [  9216,  12288,  15360,  18432 ], // 3840 x 2160, 7.91M
        [  7680,  10240,  12800,  15360 ], // 2048 x 2048, 4.00M
        [   832,   1664,   2496,   3328 ], //  512 x  512, 0.25M
        [  1152,   2304,   3456,   4608 ], //  720 x  576, 0.40M
        [  8192,  10922,  13654,  16384 ], // 2560 x 2048, 5.00M
        [  4096,   8192,  10240,  12288 ], // 2048 x 1024, 2.00M
        [  2176,   4352,   6528,   8704 ], // 2048 x  512, 1.00M
        [  4266,   8534,  10668,  12800 ], // 1536 x 1536, 2.25M
        [  1408,   2816,   4224,   5632 ], // 1024 x  512, 0.50M
        [  2820,   5642,   7782,   9728 ], // 1280 x 1024, 1.25M
        [   972,   1944,   2918,   3890 ], //  640 x  512, 0.31M
        [  1152,   2304,   3456,   4608 ], //  720 x  480, 0.33M

        [  5734,   9558,  11948,  14336 ], // 2048 x 1536, 3.00M
        [  3924,   7850,   9814,  11776 ], // 1600 x 1200, 1.83M
        [  2970,   5938,   8192,  10240 ], // 1400 x 1050, 1.40M
        [  2672,   5344,   7372,   9216 ], // 1280 x  960, 1.17M
        [  1792,   3584,   5376,   7168 ], // 1024 x  768, 0.75M
        [  1280,   2560,   3840,   5120 ], //  800 x  600, 0.46M
        [   512,   1024,   1536,   2048 ], //  480 x  360, 0.16M
        [   384,    768,   1152,   1536 ], //  400 x  300, 0.11M
        [   230,    460,    692,    922 ], //  240 x  180, 0.04M
        [  8088,  10786,  13482,  16178 ]];// 1592 x 1944, 4.81M
        
    var H265_BITRATE = 
       [[   128,    256,    384,    512 ], // G2_IMAGE_RESOLUTION_CIF,    352 x  240, 0.08M
        [   256,    512,    768,   1024 ], // G2_IMAGE_RESOLUTION_2CIF,   704 x  240, 0.16M
        [   512,   1024,   1536,   2048 ], // G2_IMAGE_RESOLUTION_4CIF,   704 x  480, 0.32M
        [  1024,   2048,   3072,   4096 ], // G2_IMAGE_RESOLUTION_720P,  1280 x  720, 0.88M
        [  2048,   4096,   5120,   6144 ], // G2_IMAGE_RESOLUTION_1080P, 1920 x 1080, 1.98M
        [   384,    768,   1152,   1536 ], // G2_IMAGE_RESOLUTION_NHD,    640 x  360, 0.22M
        [   125,    251,    376,    502 ], // G2_IMAGE_RESOLUTION_QVGA,   320 x  240, 0.07M
        [   448,    896,   1344,   1792 ], // G2_IMAGE_RESOLUTION_VGA,    640 x  480, 0.29M
        [  2765,   4608,   5760,   6912 ], // G2_IMAGE_RESOLUTION_3M,    2304 x 1296, 2.85M
        [     0,      0,      0,      0 ], // Custom

        [  1088,   2176,   3264,   4352 ], // 1024 x 1024, 1.00M
        [  4608,   6144,   7680,   9216 ], // 3840 x 2160, 7.91M
        [  3840,   5120,   6400,   7680 ], // 2048 x 2048, 4.00M
        [   416,    832,   1248,   1664 ], //  512 x  512, 0.25M
        [   576,   1152,   1728,   2304 ], //  720 x  576, 0.40M
        [  4096,   5461,   6827,   8192 ], // 2560 x 2048, 5.00M
        [  2048,   4096,   5120,   6144 ], // 2048 x 1024, 2.00M
        [  1088,   2176,   3264,   4352 ], // 2048 x  512, 1.00M
        [  2133,   4267,   5334,   6400 ], // 1536 x 1536, 2.25M
        [   704,   1408,   2112,   2816 ], // 1024 x  512, 0.50M
        [  1410,   2821,   3891,   4864 ], // 1280 x 1024, 1.25M
        [   486,    972,   1459,   1945 ], //  640 x  512, 0.31M
        [   576,   1152,   1728,   2304 ], //  720 x  480, 0.33M

        [  2867,   4779,   5974,   7168 ], // 2048 x 1536, 3.00M
        [  1962,   3925,   4907,   5888 ], // 1600 x 1200, 1.83M
        [  1485,   2969,   4096,   5120 ], // 1400 x 1050, 1.40M
        [  1336,   2672,   3686,   4608 ], // 1280 x  960, 1.17M
        [   896,   1792,   2688,   3584 ], // 1024 x  768, 0.75M
        [   640,   1280,   1920,   2560 ], //  800 x  600, 0.46M
        [   256,    512,    768,   1024 ], //  480 x  360, 0.16M
        [   192,    384,    576,    768 ], //  400 x  300, 0.11M
        [   115,    230,    346,    461 ], //  240 x  180, 0.04M
        [  4044,   5393,    6741,  8089 ]]; // 1592 x 1944, 4.81M

    var fps_scale = [             // 10 * sqrt(fps)
            0,
            10, 14, 17, 20, 22, 24, 26, 28, 30, 32,
            33, 35, 36, 37, 39, 40, 41, 42, 44, 45,
            46, 47, 48, 49, 50, 51, 52, 53, 54, 55,
            55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
            55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
            55, 55, 55, 55, 55, 55, 55, 55, 55, 55];

    var res_bias = [
            10, // 352x240
             9, // 704x240
             8, // 704x480
             2, // 1280x720
             0, // 1920x1080
             8, // 640x360
            10, // 320x240
             8, // 640x480
             0, // 3M
             0, // CUSTOM
             2, // 1024x1024
             0, // 3840x2160
             0, // 2048x2048
             8, // 512x512
             7, // 720x576
             0, // 2560x2048
             0, // 2048x1024
             2, // 2048x512
             0, // 1536x1536
             2, // 1024x512
             1, // 1280x1024
             8, // 640x512
             8, // 720x480
             0, // 2048x1536
             0, // 1600x1200
             1, // 1400x1050
             2, // 1280x960
             4, // 1024x768
             6, // 800x600
             9, // 480x360
             9, // 400x300
             10,// 240x180
             0, // 1592 x 1944
             ];

        var bitrate = 0;
        var maxBitrate = 0;
        var resIndex = findResolution(this.codec_list[0], resolution);
        
        switch (resIndex) {
            case RES_352_240: resIdx = 0; break;
            case RES_640_360: resIdx = 0; break;
            case RES_704_480: resIdx = 2; break;
            case RES_1280_720: resIdx = 3; break;
            case RES_1920_1080: resIdx = 4; break;
            case RES_2304_1296: resIdx = 8; break;
        }
        
        switch (codec) {
            case 0: maxBitrate = H264_BITRATE[resIdx][quality]; break;
            case 1: maxBitrate = H265_BITRATE[resIdx][quality]; break;
        }
        
        if (directIP) {
           if (resIndex == RES_1920_1080) {
               if (codec == 0) {
                   H264_BITRATE[resIdx] = [4096, 6144, 8192, 10240];
               }
               else if (codec == 1) {
                   H265_BITRATE[resIdx] = [2048, 3072, 4096, 5120];
               }
           }
        }
    
        if (30 == ips) {
            bitrate = maxBitrate;
        }
        else {
            if (60 == ips)  maxBitrate = (maxBitrate * 3) >> 1;
            bitrate = maxBitrate * (fps_scale[ips] + res_bias[resIdx]) / (fps_scale[30] + res_bias[resIdx]);
        }
        
        return bitrate;
}

function s2_platform_camera_bitrate(resolution, quality, ips, max_ips, codec, directIP)
{
    var ips_idx = 0;
    var bitrate_arr = [];
    
    if (!directIP) {
        bitrate_arr = 
        [
            [
                [0.076923, 0.092308, 0.103846, 0.115385, 0.123077, 0.161538, 0.188462, 0.250000, 0.375000], // Basic
                [0.153846, 0.184615, 0.207692, 0.230769, 0.246154, 0.323077, 0.376923, 0.500000, 0.750000], // Standard
                [0.230769, 0.276923, 0.311538, 0.346154, 0.369231, 0.484615, 0.565385, 0.750000, 1.125000], // High
                [0.307692, 0.369231, 0.415385, 0.461538, 0.492308, 0.646154, 0.753846, 1.000000, 1.500000]   // Very High 
            ],  // 352 x 240
            [
                [0, 0, 0, 0, 0, 0, 0, 0, 0],    // Basic
                [0, 0, 0, 0, 0, 0, 0, 0, 0],    // Standard
                [0, 0, 0, 0, 0, 0, 0, 0, 0],    // High
                [0, 0, 0, 0, 0, 0, 0, 0, 0]      // Very High
            ], // 640 x 360
            [
                [0.285714, 0.349206, 0.396825, 0.444444, 0.476190, 0.634921, 0.746032, 1.000000, 1.500000], // Basic
                [0.571429, 0.698413, 0.793651, 0.888889, 0.952381, 1.269841, 1.492063, 2.000000, 3.000000],   // Standard
                [0.857143, 1.047619, 1.190476, 1.333333, 1.428571, 1.904762, 2.238095, 3.000000, 4.500000],  // High
                [1.142857, 1.396825, 1.587302, 1.777778, 1.904762, 2.539683, 2.984127, 4.000000, 6.000000]     // Very High
            ], // 704 x 480
            [
                [0.421053, 0.561404, 0.666667, 0.771930, 0.842105, 1.192982, 1.438596, 2.000000, 3.000000], // Basic
                [0.842105, 1.122807, 1.333333, 1.543860, 1.684211, 2.385965, 2.877193, 4.000000, 6.000000],  // Standard 
                [1.263158, 1.684211, 2.000000, 2.315789, 2.526316, 3.578947, 4.315789, 6.000000, 9.000000],  // High
                [1.684211, 2.245614, 2.666667, 3.087719, 3.368421, 4.771930, 5.754386, 8.000000, 12.000000]  // Very High 
            ], // 1280 x 720
            [
                [0.727273, 1.018182, 1.236364, 1.454545, 1.600000, 2.327273, 2.836364, 4.000000, 6.000000],     // Basic
                [1.454545, 2.036364, 2.472727, 2.909091, 3.200000, 4.654545, 5.672727, 8.000000, 12.000000],   // Standard
                [1.818182, 2.545455, 3.090909, 3.636364, 4.000000, 5.818182, 7.090909, 10.000000, 15.000000],   // High 
                [2.090909, 2.927273, 3.554545, 4.181818, 4.600000, 6.690909, 8.154545, 11.500000, 17.250000]    // Very High
            ], // 1920 x 1080
            [
                [1.818182, 2.545455, 3.090909, 3.636364, 4.000000, 5.818182, 7.090909, 10.000000, 0],       // Basic
                [2.181818, 3.054545, 3.709091, 4.363636, 4.800000, 6.981818, 8.509091, 12.000000, 0],       // Standard
                [2.727273, 3.818182, 4.636364, 5.454545, 6.000000, 8.727273, 10.636364, 15.000000, 0],     // High
                [3.272727, 4.581818, 5.563636, 6.545455, 7.200000, 10.472727, 12.763636, 18.000000, 0]      // Very High
            ]   // 3840 x 2160
        ];
    }
    else {
        bitrate_arr = 
        [
            [
                [0.076923, 0.092308, 0.103846, 0.115385, 0.123077, 0.161538, 0.188462, 0.250000, 0],    // Basic
                [0.153846, 0.184615, 0.207692, 0.230769, 0.246154, 0.323077, 0.376923, 0.500000, 0],    // Standard
                [0.230769, 0.276923, 0.311538, 0.346154, 0.369231, 0.484615, 0.565385, 0.750000, 0],    // High
                [0.307692, 0.369231, 0.415385, 0.461538, 0.492308, 0.646154, 0.753846, 1.000000, 0],    // Very High
            ],  // 352 x 240
            [
                [0.214286, 0.261905, 0.297619, 0.333333, 0.357143, 0.476190, 0.559524, 0.750000, 0],    // Basic
                [0.428571, 0.523810, 0.595238, 0.666667, 0.714286, 0.952381, 1.119048, 1.500000, 0],     // Standard
                [0.642857, 0.785714, 0.892857, 1.000000, 1.071429, 1.428571, 1.678571, 2.250000, 0],    // High
                [0.857143, 1.047619, 1.190476, 1.333333, 1.428571, 1.904762, 2.238095, 3.000000, 0],     // Very High
            ],  // 640 x 360
            [
                [0.285714, 0.349206, 0.396825, 0.444444, 0.476190, 0.634921, 0.746032, 1.000000, 0],   // Basic 
                [0.571429, 0.698413, 0.793651, 0.888889, 0.952381, 1.269841, 1.492063, 2.000000, 0],     // Standard
                [0.857143, 1.047619, 1.190476, 1.333333, 1.428571, 1.904762, 2.238095, 3.000000, 0],     // High
                [1.142857, 1.396825, 1.587302, 1.777778, 1.904762, 2.539683, 2.984127, 4.000000, 0],      // Very High
            ], // 704 x 480
            [
                [0.421053, 0.561404, 0.666667, 0.771930, 0.842105, 1.192982, 1.438596, 2.000000, 0],   // Basic
                [0.842105, 1.122807, 1.333333, 1.543860, 1.684211, 2.385965, 2.877193, 4.000000, 0],    // Standard
                [1.263158, 1.684211, 2.000000, 2.315789, 2.526316, 3.578947, 4.315789, 6.000000, 0],    // High
                [1.684211, 2.245614, 2.666667, 3.087719, 3.368421, 4.771930, 5.754386, 8.000000, 0],    // Very High
            ], // 1280 x 720
            [
                [0.727273, 1.018182, 1.236364, 1.454545, 1.600000, 2.327273, 2.836364, 4.000000, 0],    // Basic
                [1.090909, 1.527273, 1.854545, 2.181818, 2.400000, 3.490909, 4.254545, 6.000000, 0],    // Standard
                [1.454545, 2.036364, 2.472727, 2.909091, 3.200000, 4.654545, 5.672727, 8.000000, 0],    // High
                [1.818182, 2.545455, 3.090909, 3.636364, 4.000000, 5.818182, 7.090909, 10.000000, 0],    // Very High
            ], // 1920 x 1080
            [
                [1.818182, 2.545455, 3.090909, 3.636364, 4.000000, 5.818182, 7.090909, 10.000000, 0],       // Basic
                [2.181818, 3.054545, 3.709091, 4.363636, 4.800000, 6.981818, 8.509091, 12.000000, 0],       // Standard
                [2.727273, 3.818182, 4.636364, 5.454545, 6.000000, 8.727273, 10.636364, 15.000000, 0],     // High
                [3.272727, 4.581818, 5.563636, 6.545455, 7.200000, 10.472727, 12.763636, 18.000000, 0],     // Very High
            ] // 3840 x 2160
        ];
    }
    
    switch (ips) {
        case 1: case 2: case 3: case 4: case 5: ips_idx = ips -1; break;
        case 10: ips_idx = 5; break;
        case 15: ips_idx = 6; break;
        case 30: ips_idx = 7; break;
        case 60: ips_idx = 8; break;
    }
    
    var resIndex = findResolution(this.codec_list[0], resolution);
    
    var bitrate = bitrate_arr[resIndex][quality][ips_idx];

    return bitrate * 1024;
}

/*********************************************************************
*	Camera Model DC-B10xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-B10xx Series",	// _model
	"DC-B10xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	10	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-B11xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-B11xx Series",	// _model
	"DC-B11xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	11	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-B12xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-B12xx Series",	// _model
	"DC-B12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-B13xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-B13xx Series",	// _model
	"DC-B13xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080","2304x1296"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16,32],	// _resolutionFactor
	[10,9,8,2,0,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88],[1,1.5,2,2.5]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-D10xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-D10xx Series",	// _model
	"DC-D10xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	10	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-D11xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-D11xx Series",	// _model
	"DC-D11xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	11	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-D12xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-D12xx Series",	// _model
	"DC-D12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-D22xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-D22xx Series",	// _model
	"DC-D22xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-D13xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-D13xx Series",	// _model
	"DC-D13xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	13	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080","2304x1296"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16,32],	// _resolutionFactor
	[10,9,8,2,0,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.5,2,2.5],[1,1.5,2,2.5]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-E11xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-E11xx Series",	// _model
	"DC-E11xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	11	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-E12xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-E12xx Series",	// _model
	"DC-E12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-F11xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-F11xx Series",	// _model
	"DC-F11xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	11	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-F12xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-F12xx Series",	// _model
	"DC-F12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-S11xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-S11xx Series",	// _model
	"DC-S11xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	11	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-S12xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-S12xx Series",	// _model
	"DC-S12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-T12xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-T12xx Series",	// _model
	"DC-T12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-Z11xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-Z11xx Series",	// _model
	"DC-Z11xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	11	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DC-Z12xx Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DC-Z12xx Series",	// _model
	"DC-Z12xx Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["352x240","640x360","704x480","1280x720","1920x1080"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8,2,0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,2.5,2.88]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);



/*********************************************************************
*	Camera Model DE-110x Series
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"DE-110x Series",	// _model
	"DE-110x Series",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	12	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["360x240","640x360","720x480","960x480"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1, 2.66, 4, 4],	// _resolutionFactor
	[10,9,8,2,2],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);


/*********************************************************************
*	Camera Model  DC-Y1513
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-FE550-DP",	// _model
	"DC-Y1513",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	98,	// _model_group
    function(resolution, quality, ips, max_ips)
    {
        var bitrate = [
            [ 1 * 1024 * 1000, 2 * 1024 * 1000,  3 * 1024 * 1000,  4 * 1024 * 1024 ], // 512x512
            [ 1 * 1024 * 1000, 2 * 1024 * 1000,  3 * 1024 * 1000,  4 * 1024 * 1000 ], //640x512
            [ 1 * 1024 * 1000, 2 * 1024 * 1000,  3 * 1024 * 1000,  4 * 1024 * 1000 ], // 1024x512
            [ 2 * 1024 * 1000, 4 * 1024 * 1000,  6 * 1024 * 1000,  8 * 1024 * 1000 ], // 1024x1024
            [ 3 * 1024 * 1000, 5 * 1024 * 1000,  8 * 1024 * 1000, 10 * 1024 * 1000 ], //1280x1024
            [ 4 * 1024 * 1000, 8 * 1024 * 1000, 10 * 1024 * 1000,     11500 * 1024 ], //1536x1536
            [ 4 * 1024 * 1000, 8 * 1024 * 1000, 10 * 1024 * 1000,     11500 * 1024 ], //2048x1024
            [ 10 * 1024 * 1000, 12 * 1024 * 1000, 14 * 1024 * 1000,  16 * 1024 * 1024 ], //2560x2048
            [ 10 * 1024 * 1000, 12 * 1024 * 1000, 14 * 1024 * 1000,  16 * 1024 * 1024 ], // 2048x2048
        ];

        var res_idx = resolution;
        var calcBitrate = 0;
        var maxBitrateVal = bitrate[res_idx][quality];
        if (ips == 60) {
            calcBitrate = maxBitrateVal * 1.5;
        }   
        else {
            calcBitrate = maxBitrateVal * (ips / 30);
        }
        return calcBitrate / 1024;
    }
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["512x512","640x512","1024x512","1024x1024","1280x1024","1536x1536","2048x1024","2560x2048","2048x2048"],// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);


/*********************************************************************
*	Camera Model  DC-B1803
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-B580-DP",	// _model
	"DC-B1803",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	98,	// _model_group
    s2_platform_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080", "3840x2160"], // _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  DC-T1833WHR
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-A580-3MWH",	// _model
	"DC-T1833WHR",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	98,	// _model_group
    s2_platform_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080", "3840x2160"], // _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  DC-D3233X
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-D620-3MXD",	// _model
	"DC-D3233X",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30,60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30,60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  DC-D3233RX
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-D620-3MXI",	// _model
	"DC-D3233RX",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30,60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  DC-D3233WRX
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-D620-3MX",	// _model
	"DC-D3233WRX",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

g_camera_device_list.push(device);


/*********************************************************************
*	Camera Model  DC-E3212WRX
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-EA620-XWI",	// _model
	"DC-E3212WRX",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

g_camera_device_list.push(device);

/*********************************************************************
*	Camera Model  DC-T3233HRX
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"NC-A620-3MXH",	// _model
	"DC-T3233HRX",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	97,	// _model_group
    zircon_camera_bitrate
 );

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

/****************************Codec H265****************************/
codec = new Codec(
	"H265",	// _name
	1.066000,	// _codecFactor
    ["352x240", "640x360", "704x480", "1280x720", "1920x1080"], // _resolution
	[1,2,3,4,5,10,15,30, 60],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[4, 4, 4, 8, 12, 16, 16, 40, 40],	// _resolutionFactor
	[8, 8, 8, 2, 1.5, 0, 0, 0, 0],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,2,3,4],[1,1.66,2.66,3.33],[1,2,2.5,2.8],[1,2,2.5,2.8],[1,1.4,1.7,2],[1,1.4,1.7,2]]	// _qualityIncreseRate
);
device.codec_list.push(codec);

g_camera_device_list.push(device);

//Analog Cameras
//Analog카메라는 factor등 기타 정보들이 아~~~무 필요없다.
// factor값대신에 resolution에 해당하는 Enum match 값이나 넣어주자.
//D1		:0
//720P	:1
//960H	:2
//1080P	:3

//해당 하는 해상도의 번호를 factor에 넣어서 처리하자
/*********************************************************************
*	D1 Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"D1 Camera",	// _model
	"D1 Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	99	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	17.06,	// _codecFactor
	["Standard", "High", "Very High"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[0],	// _resolutionFactor
	[0],	// _resolutionBasi
	[0]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	960H Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"960H Camera",	// _model
	"960H Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	99	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	17.06,	// _codecFactor
	["Standard", "High", "Very High"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[2],	// _resolutionFactor
	[2],	// _resolutionBasi
	[2]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	1MP Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"1MP Camera",	// _model
	"1MP Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	99	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	17.06,	// _codecFactor
	["Standard", "High", "Very High"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[1],	// _resolutionFactor
	[1],	// _resolutionBasi
	[1]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

/*********************************************************************
*	2MP Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"2MP Camera",	// _model
	"2MP Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	99	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	17.06,	// _codecFactor
	["Standard", "High", "Very High"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["Basic","Standard","High","Very High"],	// _quality
	[3],	// _resolutionFactor
	[3],	// _resolutionBasi
	[3]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);


/*********************************************************************
*	TC-B12xx Series Camera
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"TC-B12xx Series",	// _model
//	"TC-B12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	99	// _model_group
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	17.06,	// _codecFactor
//	["Standard", "High", "Very High"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[3],	// _resolutionFactor
//	[3],	// _resolutionBasi
//	[3]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


/*********************************************************************
*	TC-D12xx Series Camera
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"TC-D12xx Series",	// _model
//	"TC-D12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	99	// _model_group
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	17.06,	// _codecFactor
//	["Standard", "High", "Very High"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[3],	// _resolutionFactor
//	[3],	// _resolutionBasi
//	[3]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


/*********************************************************************
*	TC-E12xx Series Camera
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"TC-E12xx Series",	// _model
//	"TC-E12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	99	// _model_group
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	17.06,	// _codecFactor
//	["Standard", "High", "Very High"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[3],	// _resolutionFactor
//	[3],	// _resolutionBasi
//	[3]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


/*********************************************************************
*	TC-T12xx Series Camera
*********************************************************************/
//codec_list = new Array();
//device = new CameraDevice(
//	"TC-T12xx Series",	// _model
//	"TC-T12xx Series",	// _name
//	104857600,	// _maxSingleBitrate
//	104857600,	// _maxTotalBitrate
//	1,	// _maxStreamCount
//	0,	// _audioSupport
//	codec_list,	// _codecs
//	99	// _model_group
//);

/****************************Codec H264****************************/
//codec = new Codec(
//	"H264",	// _name
//	17.06,	// _codecFactor
//	["Standard", "High", "Very High"],	// _resolution
//	[1,2,3,4,5,10,15,30],	// _framelate
//	["Basic","Standard","High","Very High"],	// _quality
//	[3],	// _resolutionFactor
//	[3],	// _resolutionBasi
//	[3]	// _qualityIncreseRate
//);
//device.codec_list.push(codec);
//g_camera_device_list.push(device);


/*********************************************************************
*	Camera Model Custom Camera
*********************************************************************/
codec_list = new Array();
device = new CameraDevice(
	"Custom Camera",	// _model
	"Custom Camera",	// _name
	104857600,	// _maxSingleBitrate
	104857600,	// _maxTotalBitrate
	1,	// _maxStreamCount
	0,	// _audioSupport
	codec_list,	// _codecs
	100	// _model_group
);

/****************************Codec H264****************************/
codec = new Codec(
	"H264",	// _name
	1.066000,	// _codecFactor
	["-","-","-"],	// _resolution
	[1,2,3,4,5,10,15,30],	// _framelate
	["-","-","-","-"],	// _quality
	[1,2.7,4,8,16],	// _resolutionFactor
	[10,9,8],	// _resolutionBasi
	[[1,2,3,4],[1,2,3,4],[1,2,3,4]]	// _qualityIncreseRate
);
device.codec_list.push(codec);
g_camera_device_list.push(device);

